// Code generated by pigeon; DO NOT EDIT.

package nosql

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"sync"
	"unicode"
	"unicode/utf8"

	"github.com/pikami/cosmium/parsers"
)

func makeSelectStmt(
	columns, fromClause, joinItems,
	whereClause interface{}, distinctClause interface{},
	count interface{}, groupByClause interface{}, orderList interface{},
	offsetClause interface{},
) (parsers.SelectStmt, error) {
	selectStmt := parsers.SelectStmt{
		SelectItems: columns.([]parsers.SelectItem),
	}

	if fromTable, ok := fromClause.(parsers.Table); ok {
		selectStmt.Table = fromTable
	}

	if joinItemsArray, ok := joinItems.([]interface{}); ok && len(joinItemsArray) > 0 {
		selectStmt.JoinItems = make([]parsers.JoinItem, len(joinItemsArray))
		for i, joinItem := range joinItemsArray {
			selectStmt.JoinItems[i] = joinItem.(parsers.JoinItem)
		}
	}

	switch v := whereClause.(type) {
	case parsers.ComparisonExpression, parsers.LogicalExpression, parsers.Constant, parsers.SelectItem:
		selectStmt.Filters = v
	}

	if distinctClause != nil {
		selectStmt.Distinct = true
	}

	if n, ok := count.(int); ok {
		selectStmt.Count = n
	}

	if offsetArr, ok := offsetClause.([]interface{}); ok && len(offsetArr) == 2 {
		if n, ok := offsetArr[0].(int); ok {
			selectStmt.Offset = n
		}

		if n, ok := offsetArr[1].(int); ok {
			selectStmt.Count = n
		}
	}

	if orderExpressions, ok := orderList.([]parsers.OrderExpression); ok {
		selectStmt.OrderExpressions = orderExpressions
	}

	if groupByClause != nil {
		selectStmt.GroupBy = groupByClause.([]parsers.SelectItem)
	}

	return selectStmt, nil
}

func makeJoin(table interface{}, column interface{}) (parsers.JoinItem, error) {
	joinItem := parsers.JoinItem{}

	if selectItem, isSelectItem := column.(parsers.SelectItem); isSelectItem {
		joinItem.SelectItem = selectItem
		joinItem.Table.Value = selectItem.Alias
	}

	if tableTyped, isTable := table.(parsers.Table); isTable {
		joinItem.Table = tableTyped
	}

	return joinItem, nil
}

func makeSelectItem(name interface{}, path interface{}, selectItemType parsers.SelectItemType) (parsers.SelectItem, error) {
	ps := path.([]interface{})

	paths := make([]string, 1)
	paths[0] = name.(string)
	for _, p := range ps {
		paths = append(paths, p.(string))
	}

	return parsers.SelectItem{Path: paths, Type: selectItemType}, nil
}

func makeColumnList(column interface{}, other_columns interface{}) ([]parsers.SelectItem, error) {
	collsAsArray := other_columns.([]interface{})
	columnList := make([]parsers.SelectItem, len(collsAsArray)+1)
	columnList[0] = column.(parsers.SelectItem)

	for i, v := range collsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			columnList[i+1] = col
		}
	}

	return columnList, nil
}

func makeSelectArray(columns interface{}) (parsers.SelectItem, error) {
	return parsers.SelectItem{
		SelectItems: columns.([]parsers.SelectItem),
		Type:        parsers.SelectItemTypeArray,
	}, nil
}

func makeSelectObject(field interface{}, other_fields interface{}) (parsers.SelectItem, error) {
	fieldsAsArray := other_fields.([]interface{})
	fieldsList := make([]parsers.SelectItem, len(fieldsAsArray)+1)
	fieldsList[0] = field.(parsers.SelectItem)

	for i, v := range fieldsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			fieldsList[i+1] = col
		}
	}

	return parsers.SelectItem{
		SelectItems: fieldsList,
		Type:        parsers.SelectItemTypeObject,
	}, nil
}

func makeOrderByClause(ex1 interface{}, others interface{}) ([]parsers.OrderExpression, error) {
	othersArray := others.([]interface{})
	orderList := make([]parsers.OrderExpression, len(othersArray)+1)
	orderList[0] = ex1.(parsers.OrderExpression)

	for i, v := range othersArray {
		if col, ok := v.(parsers.OrderExpression); ok {
			orderList[i+1] = col
		}
	}

	return orderList, nil
}

func makeOrderExpression(field interface{}, order interface{}) (parsers.OrderExpression, error) {
	value := parsers.OrderExpression{
		SelectItem: field.(parsers.SelectItem),
		Direction:  parsers.OrderDirectionAsc,
	}

	if orderValue, ok := order.(parsers.OrderDirection); ok {
		value.Direction = orderValue
	}

	return value, nil
}

func createFunctionCall(functionType parsers.FunctionCallType, arguments []interface{}) (parsers.FunctionCall, error) {
	return parsers.FunctionCall{Type: functionType, Arguments: arguments}, nil
}

func joinStrings(array []interface{}) string {
	var stringsArray []string
	for _, elem := range array {
		str, ok := elem.(string)
		if !ok {
			continue
		}
		stringsArray = append(stringsArray, str)
	}

	return strings.Join(stringsArray, "")
}

func combineExpressions(ex1 interface{}, exs interface{}, operation parsers.LogicalExpressionType) (interface{}, error) {
	if exs == nil || len(exs.([]interface{})) < 1 {
		return ex1, nil
	}

	return parsers.LogicalExpression{
		Expressions: append([]interface{}{ex1}, exs.([]interface{})...),
		Operation:   operation,
	}, nil
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 183, col: 1, offset: 4923},
			expr: &actionExpr{
				pos: position{line: 183, col: 10, offset: 4932},
				run: (*parser).callonInput1,
				expr: &labeledExpr{
					pos:   position{line: 183, col: 10, offset: 4932},
					label: "selectStmt",
					expr: &ruleRefExpr{
						pos:  position{line: 183, col: 21, offset: 4943},
						name: "SelectStmt",
					},
				},
			},
		},
		{
			name: "SelectStmt",
			pos:  position{line: 187, col: 1, offset: 4986},
			expr: &actionExpr{
				pos: position{line: 187, col: 15, offset: 5000},
				run: (*parser).callonSelectStmt1,
				expr: &seqExpr{
					pos: position{line: 187, col: 15, offset: 5000},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 187, col: 15, offset: 5000},
							name: "Select",
						},
						&ruleRefExpr{
							pos:  position{line: 187, col: 22, offset: 5007},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 188, col: 5, offset: 5014},
							label: "distinctClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 188, col: 20, offset: 5029},
								expr: &ruleRefExpr{
									pos:  position{line: 188, col: 20, offset: 5029},
									name: "DistinctClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 188, col: 36, offset: 5045},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 189, col: 5, offset: 5052},
							label: "topClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 189, col: 15, offset: 5062},
								expr: &ruleRefExpr{
									pos:  position{line: 189, col: 15, offset: 5062},
									name: "TopClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 189, col: 26, offset: 5073},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 190, col: 5, offset: 5080},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 190, col: 13, offset: 5088},
								name: "Selection",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 190, col: 23, offset: 5098},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 191, col: 5, offset: 5105},
							label: "fromClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 191, col: 16, offset: 5116},
								expr: &ruleRefExpr{
									pos:  position{line: 191, col: 16, offset: 5116},
									name: "FromClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 191, col: 28, offset: 5128},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 192, col: 5, offset: 5135},
							label: "joinClauses",
							expr: &zeroOrMoreExpr{
								pos: position{line: 192, col: 17, offset: 5147},
								expr: &actionExpr{
									pos: position{line: 192, col: 18, offset: 5148},
									run: (*parser).callonSelectStmt22,
									expr: &seqExpr{
										pos: position{line: 192, col: 18, offset: 5148},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 192, col: 18, offset: 5148},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 192, col: 21, offset: 5151},
												label: "join",
												expr: &ruleRefExpr{
													pos:  position{line: 192, col: 26, offset: 5156},
													name: "JoinClause",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 192, col: 60, offset: 5190},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 193, col: 5, offset: 5197},
							label: "whereClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 193, col: 17, offset: 5209},
								expr: &actionExpr{
									pos: position{line: 193, col: 18, offset: 5210},
									run: (*parser).callonSelectStmt30,
									expr: &seqExpr{
										pos: position{line: 193, col: 18, offset: 5210},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 193, col: 18, offset: 5210},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 193, col: 21, offset: 5213},
												name: "Where",
											},
											&ruleRefExpr{
												pos:  position{line: 193, col: 27, offset: 5219},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 193, col: 30, offset: 5222},
												label: "condition",
												expr: &ruleRefExpr{
													pos:  position{line: 193, col: 40, offset: 5232},
													name: "Condition",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 194, col: 5, offset: 5274},
							label: "groupByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 194, col: 19, offset: 5288},
								expr: &actionExpr{
									pos: position{line: 194, col: 20, offset: 5289},
									run: (*parser).callonSelectStmt39,
									expr: &seqExpr{
										pos: position{line: 194, col: 20, offset: 5289},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 194, col: 20, offset: 5289},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 194, col: 23, offset: 5292},
												name: "GroupBy",
											},
											&ruleRefExpr{
												pos:  position{line: 194, col: 31, offset: 5300},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 194, col: 34, offset: 5303},
												label: "columns",
												expr: &ruleRefExpr{
													pos:  position{line: 194, col: 42, offset: 5311},
													name: "ColumnList",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 195, col: 5, offset: 5352},
							label: "orderByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 195, col: 19, offset: 5366},
								expr: &actionExpr{
									pos: position{line: 195, col: 20, offset: 5367},
									run: (*parser).callonSelectStmt48,
									expr: &seqExpr{
										pos: position{line: 195, col: 20, offset: 5367},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 195, col: 20, offset: 5367},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 195, col: 23, offset: 5370},
												label: "order",
												expr: &ruleRefExpr{
													pos:  position{line: 195, col: 29, offset: 5376},
													name: "OrderByClause",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 196, col: 5, offset: 5418},
							label: "offsetClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 196, col: 18, offset: 5431},
								expr: &actionExpr{
									pos: position{line: 196, col: 19, offset: 5432},
									run: (*parser).callonSelectStmt55,
									expr: &seqExpr{
										pos: position{line: 196, col: 19, offset: 5432},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 196, col: 19, offset: 5432},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 196, col: 22, offset: 5435},
												label: "offset",
												expr: &ruleRefExpr{
													pos:  position{line: 196, col: 29, offset: 5442},
													name: "OffsetClause",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "DistinctClause",
			pos:  position{line: 201, col: 1, offset: 5637},
			expr: &litMatcher{
				pos:        position{line: 201, col: 19, offset: 5655},
				val:        "distinct",
				ignoreCase: true,
				want:       "\"DISTINCT\"i",
			},
		},
		{
			name: "TopClause",
			pos:  position{line: 203, col: 1, offset: 5668},
			expr: &actionExpr{
				pos: position{line: 203, col: 14, offset: 5681},
				run: (*parser).callonTopClause1,
				expr: &seqExpr{
					pos: position{line: 203, col: 14, offset: 5681},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 203, col: 14, offset: 5681},
							name: "Top",
						},
						&ruleRefExpr{
							pos:  position{line: 203, col: 18, offset: 5685},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 203, col: 21, offset: 5688},
							label: "count",
							expr: &ruleRefExpr{
								pos:  position{line: 203, col: 27, offset: 5694},
								name: "Integer",
							},
						},
					},
				},
			},
		},
		{
			name: "FromClause",
			pos:  position{line: 207, col: 1, offset: 5729},
			expr: &choiceExpr{
				pos: position{line: 207, col: 15, offset: 5743},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 207, col: 15, offset: 5743},
						run: (*parser).callonFromClause2,
						expr: &seqExpr{
							pos: position{line: 207, col: 15, offset: 5743},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 207, col: 15, offset: 5743},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 207, col: 20, offset: 5748},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 207, col: 23, offset: 5751},
									label: "table",
									expr: &ruleRefExpr{
										pos:  position{line: 207, col: 29, offset: 5757},
										name: "TableName",
									},
								},
								&labeledExpr{
									pos:   position{line: 207, col: 39, offset: 5767},
									label: "selectItem",
									expr: &zeroOrOneExpr{
										pos: position{line: 207, col: 50, offset: 5778},
										expr: &actionExpr{
											pos: position{line: 207, col: 51, offset: 5779},
											run: (*parser).callonFromClause10,
											expr: &seqExpr{
												pos: position{line: 207, col: 51, offset: 5779},
												exprs: []any{
													&ruleRefExpr{
														pos:  position{line: 207, col: 51, offset: 5779},
														name: "ws",
													},
													&litMatcher{
														pos:        position{line: 207, col: 54, offset: 5782},
														val:        "in",
														ignoreCase: true,
														want:       "\"IN\"i",
													},
													&ruleRefExpr{
														pos:  position{line: 207, col: 60, offset: 5788},
														name: "ws",
													},
													&labeledExpr{
														pos:   position{line: 207, col: 63, offset: 5791},
														label: "column",
														expr: &ruleRefExpr{
															pos:  position{line: 207, col: 70, offset: 5798},
															name: "SelectItem",
														},
													},
												},
											},
										},
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 215, col: 5, offset: 5997},
						run: (*parser).callonFromClause17,
						expr: &seqExpr{
							pos: position{line: 215, col: 5, offset: 5997},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 215, col: 5, offset: 5997},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 215, col: 10, offset: 6002},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 215, col: 13, offset: 6005},
									label: "subQuery",
									expr: &ruleRefExpr{
										pos:  position{line: 215, col: 22, offset: 6014},
										name: "SubQuerySelectItem",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SubQuery",
			pos:  position{line: 224, col: 1, offset: 6195},
			expr: &actionExpr{
				pos: position{line: 224, col: 13, offset: 6207},
				run: (*parser).callonSubQuery1,
				expr: &seqExpr{
					pos: position{line: 224, col: 13, offset: 6207},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 224, col: 13, offset: 6207},
							label: "exists",
							expr: &zeroOrOneExpr{
								pos: position{line: 224, col: 20, offset: 6214},
								expr: &actionExpr{
									pos: position{line: 224, col: 21, offset: 6215},
									run: (*parser).callonSubQuery5,
									expr: &seqExpr{
										pos: position{line: 224, col: 21, offset: 6215},
										exprs: []any{
											&labeledExpr{
												pos:   position{line: 224, col: 21, offset: 6215},
												label: "exists",
												expr: &ruleRefExpr{
													pos:  position{line: 224, col: 28, offset: 6222},
													name: "Exists",
												},
											},
											&ruleRefExpr{
												pos:  position{line: 224, col: 35, offset: 6229},
												name: "ws",
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 224, col: 63, offset: 6257},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 224, col: 67, offset: 6261},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 224, col: 70, offset: 6264},
							label: "selectStmt",
							expr: &ruleRefExpr{
								pos:  position{line: 224, col: 81, offset: 6275},
								name: "SelectStmt",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 224, col: 92, offset: 6286},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 224, col: 95, offset: 6289},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubQuerySelectItem",
			pos:  position{line: 233, col: 1, offset: 6501},
			expr: &actionExpr{
				pos: position{line: 233, col: 23, offset: 6523},
				run: (*parser).callonSubQuerySelectItem1,
				expr: &seqExpr{
					pos: position{line: 233, col: 23, offset: 6523},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 233, col: 23, offset: 6523},
							label: "subQuery",
							expr: &ruleRefExpr{
								pos:  position{line: 233, col: 32, offset: 6532},
								name: "SubQuery",
							},
						},
						&labeledExpr{
							pos:   position{line: 233, col: 41, offset: 6541},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 233, col: 50, offset: 6550},
								expr: &actionExpr{
									pos: position{line: 233, col: 51, offset: 6551},
									run: (*parser).callonSubQuerySelectItem7,
									expr: &seqExpr{
										pos: position{line: 233, col: 51, offset: 6551},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 233, col: 51, offset: 6551},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 233, col: 54, offset: 6554},
												label: "alias",
												expr: &ruleRefExpr{
													pos:  position{line: 233, col: 60, offset: 6560},
													name: "AsClause",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "JoinClause",
			pos:  position{line: 246, col: 1, offset: 6845},
			expr: &choiceExpr{
				pos: position{line: 246, col: 15, offset: 6859},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 246, col: 15, offset: 6859},
						run: (*parser).callonJoinClause2,
						expr: &seqExpr{
							pos: position{line: 246, col: 15, offset: 6859},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 246, col: 15, offset: 6859},
									name: "Join",
								},
								&ruleRefExpr{
									pos:  position{line: 246, col: 20, offset: 6864},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 246, col: 23, offset: 6867},
									label: "table",
									expr: &ruleRefExpr{
										pos:  position{line: 246, col: 29, offset: 6873},
										name: "TableName",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 246, col: 39, offset: 6883},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 246, col: 42, offset: 6886},
									val:        "in",
									ignoreCase: true,
									want:       "\"IN\"i",
								},
								&ruleRefExpr{
									pos:  position{line: 246, col: 48, offset: 6892},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 246, col: 51, offset: 6895},
									label: "column",
									expr: &ruleRefExpr{
										pos:  position{line: 246, col: 58, offset: 6902},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 248, col: 5, offset: 6954},
						run: (*parser).callonJoinClause13,
						expr: &seqExpr{
							pos: position{line: 248, col: 5, offset: 6954},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 248, col: 5, offset: 6954},
									name: "Join",
								},
								&ruleRefExpr{
									pos:  position{line: 248, col: 10, offset: 6959},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 248, col: 13, offset: 6962},
									label: "subQuery",
									expr: &ruleRefExpr{
										pos:  position{line: 248, col: 22, offset: 6971},
										name: "SubQuerySelectItem",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OffsetClause",
			pos:  position{line: 252, col: 1, offset: 7030},
			expr: &actionExpr{
				pos: position{line: 252, col: 17, offset: 7046},
				run: (*parser).callonOffsetClause1,
				expr: &seqExpr{
					pos: position{line: 252, col: 17, offset: 7046},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 252, col: 17, offset: 7046},
							val:        "offset",
							ignoreCase: true,
							want:       "\"OFFSET\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 252, col: 27, offset: 7056},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 252, col: 30, offset: 7059},
							label: "offset",
							expr: &ruleRefExpr{
								pos:  position{line: 252, col: 37, offset: 7066},
								name: "IntegerLiteral",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 252, col: 52, offset: 7081},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 252, col: 55, offset: 7084},
							val:        "limit",
							ignoreCase: true,
							want:       "\"LIMIT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 252, col: 64, offset: 7093},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 252, col: 67, offset: 7096},
							label: "limit",
							expr: &ruleRefExpr{
								pos:  position{line: 252, col: 73, offset: 7102},
								name: "IntegerLiteral",
							},
						},
					},
				},
			},
		},
		{
			name: "Selection",
			pos:  position{line: 256, col: 1, offset: 7217},
			expr: &choiceExpr{
				pos: position{line: 256, col: 14, offset: 7230},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 256, col: 14, offset: 7230},
						name: "SelectValueSpec",
					},
					&ruleRefExpr{
						pos:  position{line: 256, col: 32, offset: 7248},
						name: "ColumnList",
					},
					&ruleRefExpr{
						pos:  position{line: 256, col: 45, offset: 7261},
						name: "SelectAsterisk",
					},
				},
			},
		},
		{
			name: "SelectAsterisk",
			pos:  position{line: 258, col: 1, offset: 7277},
			expr: &actionExpr{
				pos: position{line: 258, col: 19, offset: 7295},
				run: (*parser).callonSelectAsterisk1,
				expr: &litMatcher{
					pos:        position{line: 258, col: 19, offset: 7295},
					val:        "*",
					ignoreCase: false,
					want:       "\"*\"",
				},
			},
		},
		{
			name: "ColumnList",
			pos:  position{line: 264, col: 1, offset: 7490},
			expr: &actionExpr{
				pos: position{line: 264, col: 15, offset: 7504},
				run: (*parser).callonColumnList1,
				expr: &seqExpr{
					pos: position{line: 264, col: 15, offset: 7504},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 264, col: 15, offset: 7504},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 264, col: 22, offset: 7511},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 264, col: 33, offset: 7522},
							label: "other_columns",
							expr: &zeroOrMoreExpr{
								pos: position{line: 264, col: 47, offset: 7536},
								expr: &actionExpr{
									pos: position{line: 264, col: 48, offset: 7537},
									run: (*parser).callonColumnList7,
									expr: &seqExpr{
										pos: position{line: 264, col: 48, offset: 7537},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 264, col: 48, offset: 7537},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 264, col: 51, offset: 7540},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 264, col: 55, offset: 7544},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 264, col: 58, offset: 7547},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 264, col: 63, offset: 7552},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectValueSpec",
			pos:  position{line: 268, col: 1, offset: 7639},
			expr: &actionExpr{
				pos: position{line: 268, col: 20, offset: 7658},
				run: (*parser).callonSelectValueSpec1,
				expr: &seqExpr{
					pos: position{line: 268, col: 20, offset: 7658},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 268, col: 20, offset: 7658},
							val:        "value",
							ignoreCase: true,
							want:       "\"VALUE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 268, col: 29, offset: 7667},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 268, col: 32, offset: 7670},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 268, col: 39, offset: 7677},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "TableName",
			pos:  position{line: 274, col: 1, offset: 7831},
			expr: &actionExpr{
				pos: position{line: 274, col: 14, offset: 7844},
				run: (*parser).callonTableName1,
				expr: &labeledExpr{
					pos:   position{line: 274, col: 14, offset: 7844},
					label: "key",
					expr: &ruleRefExpr{
						pos:  position{line: 274, col: 18, offset: 7848},
						name: "Identifier",
					},
				},
			},
		},
		{
			name: "SelectArray",
			pos:  position{line: 278, col: 1, offset: 7915},
			expr: &actionExpr{
				pos: position{line: 278, col: 16, offset: 7930},
				run: (*parser).callonSelectArray1,
				expr: &seqExpr{
					pos: position{line: 278, col: 16, offset: 7930},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 278, col: 16, offset: 7930},
							val:        "[",
							ignoreCase: false,
							want:       "\"[\"",
						},
						&ruleRefExpr{
							pos:  position{line: 278, col: 20, offset: 7934},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 278, col: 23, offset: 7937},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 278, col: 31, offset: 7945},
								name: "ColumnList",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 278, col: 42, offset: 7956},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 278, col: 45, offset: 7959},
							val:        "]",
							ignoreCase: false,
							want:       "\"]\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObject",
			pos:  position{line: 282, col: 1, offset: 8004},
			expr: &actionExpr{
				pos: position{line: 282, col: 17, offset: 8020},
				run: (*parser).callonSelectObject1,
				expr: &seqExpr{
					pos: position{line: 282, col: 17, offset: 8020},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 282, col: 17, offset: 8020},
							val:        "{",
							ignoreCase: false,
							want:       "\"{\"",
						},
						&ruleRefExpr{
							pos:  position{line: 282, col: 21, offset: 8024},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 282, col: 24, offset: 8027},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 282, col: 30, offset: 8033},
								name: "SelectObjectField",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 282, col: 48, offset: 8051},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 282, col: 51, offset: 8054},
							label: "other_fields",
							expr: &zeroOrMoreExpr{
								pos: position{line: 282, col: 64, offset: 8067},
								expr: &actionExpr{
									pos: position{line: 282, col: 65, offset: 8068},
									run: (*parser).callonSelectObject10,
									expr: &seqExpr{
										pos: position{line: 282, col: 65, offset: 8068},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 282, col: 65, offset: 8068},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 282, col: 68, offset: 8071},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 282, col: 72, offset: 8075},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 282, col: 75, offset: 8078},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 282, col: 80, offset: 8083},
													name: "SelectObjectField",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 282, col: 120, offset: 8123},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 282, col: 123, offset: 8126},
							val:        "}",
							ignoreCase: false,
							want:       "\"}\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObjectField",
			pos:  position{line: 286, col: 1, offset: 8184},
			expr: &actionExpr{
				pos: position{line: 286, col: 22, offset: 8205},
				run: (*parser).callonSelectObjectField1,
				expr: &seqExpr{
					pos: position{line: 286, col: 22, offset: 8205},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 286, col: 22, offset: 8205},
							label: "name",
							expr: &choiceExpr{
								pos: position{line: 286, col: 28, offset: 8211},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 286, col: 28, offset: 8211},
										name: "Identifier",
									},
									&actionExpr{
										pos: position{line: 286, col: 41, offset: 8224},
										run: (*parser).callonSelectObjectField6,
										expr: &seqExpr{
											pos: position{line: 286, col: 41, offset: 8224},
											exprs: []any{
												&litMatcher{
													pos:        position{line: 286, col: 41, offset: 8224},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
												&labeledExpr{
													pos:   position{line: 286, col: 46, offset: 8229},
													label: "key",
													expr: &ruleRefExpr{
														pos:  position{line: 286, col: 50, offset: 8233},
														name: "Identifier",
													},
												},
												&litMatcher{
													pos:        position{line: 286, col: 61, offset: 8244},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 286, col: 87, offset: 8270},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 286, col: 90, offset: 8273},
							val:        ":",
							ignoreCase: false,
							want:       "\":\"",
						},
						&ruleRefExpr{
							pos:  position{line: 286, col: 94, offset: 8277},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 286, col: 97, offset: 8280},
							label: "selectItem",
							expr: &ruleRefExpr{
								pos:  position{line: 286, col: 108, offset: 8291},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "SelectProperty",
			pos:  position{line: 292, col: 1, offset: 8397},
			expr: &actionExpr{
				pos: position{line: 292, col: 19, offset: 8415},
				run: (*parser).callonSelectProperty1,
				expr: &seqExpr{
					pos: position{line: 292, col: 19, offset: 8415},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 292, col: 19, offset: 8415},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 292, col: 24, offset: 8420},
								name: "Identifier",
							},
						},
						&labeledExpr{
							pos:   position{line: 292, col: 35, offset: 8431},
							label: "path",
							expr: &zeroOrMoreExpr{
								pos: position{line: 292, col: 40, offset: 8436},
								expr: &choiceExpr{
									pos: position{line: 292, col: 41, offset: 8437},
									alternatives: []any{
										&ruleRefExpr{
											pos:  position{line: 292, col: 41, offset: 8437},
											name: "DotFieldAccess",
										},
										&ruleRefExpr{
											pos:  position{line: 292, col: 58, offset: 8454},
											name: "ArrayFieldAccess",
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectItem",
			pos:  position{line: 296, col: 1, offset: 8545},
			expr: &actionExpr{
				pos: position{line: 296, col: 15, offset: 8559},
				run: (*parser).callonSelectItem1,
				expr: &seqExpr{
					pos: position{line: 296, col: 15, offset: 8559},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 296, col: 15, offset: 8559},
							label: "selectItem",
							expr: &choiceExpr{
								pos: position{line: 296, col: 27, offset: 8571},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 296, col: 27, offset: 8571},
										name: "SubQuerySelectItem",
									},
									&ruleRefExpr{
										pos:  position{line: 296, col: 48, offset: 8592},
										name: "Literal",
									},
									&ruleRefExpr{
										pos:  position{line: 296, col: 58, offset: 8602},
										name: "FunctionCall",
									},
									&ruleRefExpr{
										pos:  position{line: 296, col: 73, offset: 8617},
										name: "SelectArray",
									},
									&ruleRefExpr{
										pos:  position{line: 296, col: 87, offset: 8631},
										name: "SelectObject",
									},
									&ruleRefExpr{
										pos:  position{line: 296, col: 102, offset: 8646},
										name: "SelectProperty",
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 296, col: 118, offset: 8662},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 296, col: 127, offset: 8671},
								expr: &ruleRefExpr{
									pos:  position{line: 296, col: 127, offset: 8671},
									name: "AsClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AsClause",
			pos:  position{line: 320, col: 1, offset: 9269},
			expr: &actionExpr{
				pos: position{line: 320, col: 13, offset: 9281},
				run: (*parser).callonAsClause1,
				expr: &seqExpr{
					pos: position{line: 320, col: 13, offset: 9281},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 320, col: 13, offset: 9281},
							name: "ws",
						},
						&ruleRefExpr{
							pos:  position{line: 320, col: 16, offset: 9284},
							name: "As",
						},
						&ruleRefExpr{
							pos:  position{line: 320, col: 19, offset: 9287},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 320, col: 22, offset: 9290},
							label: "alias",
							expr: &ruleRefExpr{
								pos:  position{line: 320, col: 28, offset: 9296},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "DotFieldAccess",
			pos:  position{line: 322, col: 1, offset: 9330},
			expr: &actionExpr{
				pos: position{line: 322, col: 19, offset: 9348},
				run: (*parser).callonDotFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 322, col: 19, offset: 9348},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 322, col: 19, offset: 9348},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&labeledExpr{
							pos:   position{line: 322, col: 23, offset: 9352},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 322, col: 26, offset: 9355},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ArrayFieldAccess",
			pos:  position{line: 326, col: 1, offset: 9390},
			expr: &choiceExpr{
				pos: position{line: 326, col: 21, offset: 9410},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 326, col: 21, offset: 9410},
						run: (*parser).callonArrayFieldAccess2,
						expr: &seqExpr{
							pos: position{line: 326, col: 21, offset: 9410},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 326, col: 21, offset: 9410},
									val:        "[\"",
									ignoreCase: false,
									want:       "\"[\\\"\"",
								},
								&labeledExpr{
									pos:   position{line: 326, col: 27, offset: 9416},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 326, col: 30, offset: 9419},
										name: "Identifier",
									},
								},
								&litMatcher{
									pos:        position{line: 326, col: 41, offset: 9430},
									val:        "\"]",
									ignoreCase: false,
									want:       "\"\\\"]\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 327, col: 5, offset: 9459},
						run: (*parser).callonArrayFieldAccess8,
						expr: &seqExpr{
							pos: position{line: 327, col: 5, offset: 9459},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 327, col: 5, offset: 9459},
									val:        "[",
									ignoreCase: false,
									want:       "\"[\"",
								},
								&labeledExpr{
									pos:   position{line: 327, col: 9, offset: 9463},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 327, col: 12, offset: 9466},
										name: "Integer",
									},
								},
								&litMatcher{
									pos:        position{line: 327, col: 20, offset: 9474},
									val:        "]",
									ignoreCase: false,
									want:       "\"]\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "Identifier",
			pos:  position{line: 329, col: 1, offset: 9518},
			expr: &actionExpr{
				pos: position{line: 329, col: 15, offset: 9532},
				run: (*parser).callonIdentifier1,
				expr: &seqExpr{
					pos: position{line: 329, col: 15, offset: 9532},
					exprs: []any{
						&charClassMatcher{
							pos:        position{line: 329, col: 15, offset: 9532},
							val:        "[a-zA-Z_]",
							chars:      []rune{'_'},
							ranges:     []rune{'a', 'z', 'A', 'Z'},
							ignoreCase: false,
							inverted:   false,
						},
						&zeroOrMoreExpr{
							pos: position{line: 329, col: 24, offset: 9541},
							expr: &charClassMatcher{
								pos:        position{line: 329, col: 24, offset: 9541},
								val:        "[a-zA-Z0-9_]",
								chars:      []rune{'_'},
								ranges:     []rune{'a', 'z', 'A', 'Z', '0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "Condition",
			pos:  position{line: 333, col: 1, offset: 9591},
			expr: &actionExpr{
				pos: position{line: 333, col: 14, offset: 9604},
				run: (*parser).callonCondition1,
				expr: &labeledExpr{
					pos:   position{line: 333, col: 14, offset: 9604},
					label: "expression",
					expr: &ruleRefExpr{
						pos:  position{line: 333, col: 25, offset: 9615},
						name: "OrExpression",
					},
				},
			},
		},
		{
			name: "OrExpression",
			pos:  position{line: 337, col: 1, offset: 9660},
			expr: &actionExpr{
				pos: position{line: 337, col: 17, offset: 9676},
				run: (*parser).callonOrExpression1,
				expr: &seqExpr{
					pos: position{line: 337, col: 17, offset: 9676},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 337, col: 17, offset: 9676},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 337, col: 21, offset: 9680},
								name: "AndExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 337, col: 35, offset: 9694},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 337, col: 39, offset: 9698},
								expr: &actionExpr{
									pos: position{line: 337, col: 40, offset: 9699},
									run: (*parser).callonOrExpression7,
									expr: &seqExpr{
										pos: position{line: 337, col: 40, offset: 9699},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 337, col: 40, offset: 9699},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 337, col: 43, offset: 9702},
												name: "Or",
											},
											&ruleRefExpr{
												pos:  position{line: 337, col: 46, offset: 9705},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 337, col: 49, offset: 9708},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 337, col: 52, offset: 9711},
													name: "AndExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AndExpression",
			pos:  position{line: 341, col: 1, offset: 9824},
			expr: &actionExpr{
				pos: position{line: 341, col: 18, offset: 9841},
				run: (*parser).callonAndExpression1,
				expr: &seqExpr{
					pos: position{line: 341, col: 18, offset: 9841},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 341, col: 18, offset: 9841},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 341, col: 22, offset: 9845},
								name: "ComparisonExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 341, col: 43, offset: 9866},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 341, col: 47, offset: 9870},
								expr: &actionExpr{
									pos: position{line: 341, col: 48, offset: 9871},
									run: (*parser).callonAndExpression7,
									expr: &seqExpr{
										pos: position{line: 341, col: 48, offset: 9871},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 341, col: 48, offset: 9871},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 341, col: 51, offset: 9874},
												name: "And",
											},
											&ruleRefExpr{
												pos:  position{line: 341, col: 55, offset: 9878},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 341, col: 58, offset: 9881},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 341, col: 61, offset: 9884},
													name: "ComparisonExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ComparisonExpression",
			pos:  position{line: 345, col: 1, offset: 10005},
			expr: &choiceExpr{
				pos: position{line: 345, col: 25, offset: 10029},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 345, col: 25, offset: 10029},
						run: (*parser).callonComparisonExpression2,
						expr: &seqExpr{
							pos: position{line: 345, col: 25, offset: 10029},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 345, col: 25, offset: 10029},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 345, col: 29, offset: 10033},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 345, col: 32, offset: 10036},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 345, col: 35, offset: 10039},
										name: "OrExpression",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 345, col: 48, offset: 10052},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 345, col: 51, offset: 10055},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 346, col: 7, offset: 10084},
						run: (*parser).callonComparisonExpression10,
						expr: &seqExpr{
							pos: position{line: 346, col: 7, offset: 10084},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 346, col: 7, offset: 10084},
									label: "left",
									expr: &ruleRefExpr{
										pos:  position{line: 346, col: 12, offset: 10089},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 346, col: 23, offset: 10100},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 346, col: 26, offset: 10103},
									label: "op",
									expr: &ruleRefExpr{
										pos:  position{line: 346, col: 29, offset: 10106},
										name: "ComparisonOperator",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 346, col: 48, offset: 10125},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 346, col: 51, offset: 10128},
									label: "right",
									expr: &ruleRefExpr{
										pos:  position{line: 346, col: 57, offset: 10134},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 348, col: 5, offset: 10241},
						run: (*parser).callonComparisonExpression20,
						expr: &labeledExpr{
							pos:   position{line: 348, col: 5, offset: 10241},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 348, col: 8, offset: 10244},
								name: "BooleanLiteral",
							},
						},
					},
					&actionExpr{
						pos: position{line: 349, col: 5, offset: 10282},
						run: (*parser).callonComparisonExpression23,
						expr: &labeledExpr{
							pos:   position{line: 349, col: 5, offset: 10282},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 349, col: 8, offset: 10285},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "OrderByClause",
			pos:  position{line: 351, col: 1, offset: 10316},
			expr: &actionExpr{
				pos: position{line: 351, col: 18, offset: 10333},
				run: (*parser).callonOrderByClause1,
				expr: &seqExpr{
					pos: position{line: 351, col: 18, offset: 10333},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 351, col: 18, offset: 10333},
							name: "OrderBy",
						},
						&ruleRefExpr{
							pos:  position{line: 351, col: 26, offset: 10341},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 351, col: 29, offset: 10344},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 351, col: 33, offset: 10348},
								name: "OrderExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 351, col: 49, offset: 10364},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 351, col: 56, offset: 10371},
								expr: &actionExpr{
									pos: position{line: 351, col: 57, offset: 10372},
									run: (*parser).callonOrderByClause9,
									expr: &seqExpr{
										pos: position{line: 351, col: 57, offset: 10372},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 351, col: 57, offset: 10372},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 351, col: 60, offset: 10375},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 351, col: 64, offset: 10379},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 351, col: 67, offset: 10382},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 351, col: 70, offset: 10385},
													name: "OrderExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderExpression",
			pos:  position{line: 355, col: 1, offset: 10469},
			expr: &actionExpr{
				pos: position{line: 355, col: 20, offset: 10488},
				run: (*parser).callonOrderExpression1,
				expr: &seqExpr{
					pos: position{line: 355, col: 20, offset: 10488},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 355, col: 20, offset: 10488},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 355, col: 26, offset: 10494},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 355, col: 41, offset: 10509},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 355, col: 44, offset: 10512},
							label: "order",
							expr: &zeroOrOneExpr{
								pos: position{line: 355, col: 50, offset: 10518},
								expr: &ruleRefExpr{
									pos:  position{line: 355, col: 50, offset: 10518},
									name: "OrderDirection",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderDirection",
			pos:  position{line: 359, col: 1, offset: 10584},
			expr: &actionExpr{
				pos: position{line: 359, col: 19, offset: 10602},
				run: (*parser).callonOrderDirection1,
				expr: &choiceExpr{
					pos: position{line: 359, col: 20, offset: 10603},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 359, col: 20, offset: 10603},
							val:        "asc",
							ignoreCase: true,
							want:       "\"ASC\"i",
						},
						&litMatcher{
							pos:        position{line: 359, col: 29, offset: 10612},
							val:        "desc",
							ignoreCase: true,
							want:       "\"DESC\"i",
						},
					},
				},
			},
		},
		{
			name: "Select",
			pos:  position{line: 367, col: 1, offset: 10764},
			expr: &litMatcher{
				pos:        position{line: 367, col: 11, offset: 10774},
				val:        "select",
				ignoreCase: true,
				want:       "\"SELECT\"i",
			},
		},
		{
			name: "Top",
			pos:  position{line: 369, col: 1, offset: 10785},
			expr: &litMatcher{
				pos:        position{line: 369, col: 8, offset: 10792},
				val:        "top",
				ignoreCase: true,
				want:       "\"TOP\"i",
			},
		},
		{
			name: "As",
			pos:  position{line: 371, col: 1, offset: 10800},
			expr: &litMatcher{
				pos:        position{line: 371, col: 7, offset: 10806},
				val:        "as",
				ignoreCase: true,
				want:       "\"AS\"i",
			},
		},
		{
			name: "From",
			pos:  position{line: 373, col: 1, offset: 10813},
			expr: &litMatcher{
				pos:        position{line: 373, col: 9, offset: 10821},
				val:        "from",
				ignoreCase: true,
				want:       "\"FROM\"i",
			},
		},
		{
			name: "Join",
			pos:  position{line: 375, col: 1, offset: 10830},
			expr: &litMatcher{
				pos:        position{line: 375, col: 9, offset: 10838},
				val:        "join",
				ignoreCase: true,
				want:       "\"JOIN\"i",
			},
		},
		{
			name: "Exists",
			pos:  position{line: 377, col: 1, offset: 10847},
			expr: &litMatcher{
				pos:        position{line: 377, col: 11, offset: 10857},
				val:        "exists",
				ignoreCase: true,
				want:       "\"EXISTS\"i",
			},
		},
		{
			name: "Where",
			pos:  position{line: 379, col: 1, offset: 10868},
			expr: &litMatcher{
				pos:        position{line: 379, col: 10, offset: 10877},
				val:        "where",
				ignoreCase: true,
				want:       "\"WHERE\"i",
			},
		},
		{
			name: "And",
			pos:  position{line: 381, col: 1, offset: 10887},
			expr: &litMatcher{
				pos:        position{line: 381, col: 8, offset: 10894},
				val:        "and",
				ignoreCase: true,
				want:       "\"AND\"i",
			},
		},
		{
			name: "Or",
			pos:  position{line: 383, col: 1, offset: 10902},
			expr: &seqExpr{
				pos: position{line: 383, col: 7, offset: 10908},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 383, col: 7, offset: 10908},
						val:        "or",
						ignoreCase: true,
						want:       "\"OR\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 383, col: 13, offset: 10914},
						name: "wss",
					},
				},
			},
		},
		{
			name: "GroupBy",
			pos:  position{line: 385, col: 1, offset: 10919},
			expr: &seqExpr{
				pos: position{line: 385, col: 12, offset: 10930},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 385, col: 12, offset: 10930},
						val:        "group",
						ignoreCase: true,
						want:       "\"GROUP\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 385, col: 21, offset: 10939},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 385, col: 24, offset: 10942},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "OrderBy",
			pos:  position{line: 387, col: 1, offset: 10949},
			expr: &seqExpr{
				pos: position{line: 387, col: 12, offset: 10960},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 387, col: 12, offset: 10960},
						val:        "order",
						ignoreCase: true,
						want:       "\"ORDER\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 387, col: 21, offset: 10969},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 387, col: 24, offset: 10972},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "ComparisonOperator",
			pos:  position{line: 389, col: 1, offset: 10979},
			expr: &actionExpr{
				pos: position{line: 389, col: 23, offset: 11001},
				run: (*parser).callonComparisonOperator1,
				expr: &choiceExpr{
					pos: position{line: 389, col: 24, offset: 11002},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 389, col: 24, offset: 11002},
							val:        "=",
							ignoreCase: false,
							want:       "\"=\"",
						},
						&litMatcher{
							pos:        position{line: 389, col: 30, offset: 11008},
							val:        "!=",
							ignoreCase: false,
							want:       "\"!=\"",
						},
						&litMatcher{
							pos:        position{line: 389, col: 37, offset: 11015},
							val:        "<",
							ignoreCase: false,
							want:       "\"<\"",
						},
						&litMatcher{
							pos:        position{line: 389, col: 43, offset: 11021},
							val:        "<=",
							ignoreCase: false,
							want:       "\"<=\"",
						},
						&litMatcher{
							pos:        position{line: 389, col: 50, offset: 11028},
							val:        ">",
							ignoreCase: false,
							want:       "\">\"",
						},
						&litMatcher{
							pos:        position{line: 389, col: 56, offset: 11034},
							val:        ">=",
							ignoreCase: false,
							want:       "\">=\"",
						},
					},
				},
			},
		},
		{
			name: "Literal",
			pos:  position{line: 393, col: 1, offset: 11076},
			expr: &choiceExpr{
				pos: position{line: 393, col: 12, offset: 11087},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 393, col: 12, offset: 11087},
						name: "FloatLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 393, col: 27, offset: 11102},
						name: "IntegerLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 393, col: 44, offset: 11119},
						name: "StringLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 393, col: 60, offset: 11135},
						name: "BooleanLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 393, col: 77, offset: 11152},
						name: "ParameterConstant",
					},
					&ruleRefExpr{
						pos:  position{line: 393, col: 97, offset: 11172},
						name: "NullConstant",
					},
				},
			},
		},
		{
			name: "ParameterConstant",
			pos:  position{line: 395, col: 1, offset: 11186},
			expr: &actionExpr{
				pos: position{line: 395, col: 22, offset: 11207},
				run: (*parser).callonParameterConstant1,
				expr: &seqExpr{
					pos: position{line: 395, col: 22, offset: 11207},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 395, col: 22, offset: 11207},
							val:        "@",
							ignoreCase: false,
							want:       "\"@\"",
						},
						&ruleRefExpr{
							pos:  position{line: 395, col: 26, offset: 11211},
							name: "Identifier",
						},
					},
				},
			},
		},
		{
			name: "NullConstant",
			pos:  position{line: 398, col: 1, offset: 11327},
			expr: &actionExpr{
				pos: position{line: 398, col: 17, offset: 11343},
				run: (*parser).callonNullConstant1,
				expr: &litMatcher{
					pos:        position{line: 398, col: 17, offset: 11343},
					val:        "null",
					ignoreCase: true,
					want:       "\"null\"i",
				},
			},
		},
		{
			name: "IntegerLiteral",
			pos:  position{line: 402, col: 1, offset: 11401},
			expr: &actionExpr{
				pos: position{line: 402, col: 19, offset: 11419},
				run: (*parser).callonIntegerLiteral1,
				expr: &labeledExpr{
					pos:   position{line: 402, col: 19, offset: 11419},
					label: "number",
					expr: &ruleRefExpr{
						pos:  position{line: 402, col: 26, offset: 11426},
						name: "Integer",
					},
				},
			},
		},
		{
			name: "StringLiteral",
			pos:  position{line: 405, col: 1, offset: 11527},
			expr: &actionExpr{
				pos: position{line: 405, col: 18, offset: 11544},
				run: (*parser).callonStringLiteral1,
				expr: &seqExpr{
					pos: position{line: 405, col: 18, offset: 11544},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 405, col: 18, offset: 11544},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 405, col: 23, offset: 11549},
							label: "chars",
							expr: &zeroOrMoreExpr{
								pos: position{line: 405, col: 29, offset: 11555},
								expr: &ruleRefExpr{
									pos:  position{line: 405, col: 29, offset: 11555},
									name: "StringCharacter",
								},
							},
						},
						&litMatcher{
							pos:        position{line: 405, col: 46, offset: 11572},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
					},
				},
			},
		},
		{
			name: "FloatLiteral",
			pos:  position{line: 408, col: 1, offset: 11690},
			expr: &actionExpr{
				pos: position{line: 408, col: 17, offset: 11706},
				run: (*parser).callonFloatLiteral1,
				expr: &seqExpr{
					pos: position{line: 408, col: 17, offset: 11706},
					exprs: []any{
						&oneOrMoreExpr{
							pos: position{line: 408, col: 17, offset: 11706},
							expr: &charClassMatcher{
								pos:        position{line: 408, col: 17, offset: 11706},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
						&litMatcher{
							pos:        position{line: 408, col: 23, offset: 11712},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&oneOrMoreExpr{
							pos: position{line: 408, col: 26, offset: 11715},
							expr: &charClassMatcher{
								pos:        position{line: 408, col: 26, offset: 11715},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "BooleanLiteral",
			pos:  position{line: 412, col: 1, offset: 11871},
			expr: &actionExpr{
				pos: position{line: 412, col: 19, offset: 11889},
				run: (*parser).callonBooleanLiteral1,
				expr: &choiceExpr{
					pos: position{line: 412, col: 20, offset: 11890},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 412, col: 20, offset: 11890},
							val:        "true",
							ignoreCase: true,
							want:       "\"true\"i",
						},
						&litMatcher{
							pos:        position{line: 412, col: 30, offset: 11900},
							val:        "false",
							ignoreCase: true,
							want:       "\"false\"i",
						},
					},
				},
			},
		},
		{
			name: "FunctionCall",
			pos:  position{line: 417, col: 1, offset: 12055},
			expr: &choiceExpr{
				pos: position{line: 417, col: 17, offset: 12071},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 417, col: 17, offset: 12071},
						name: "StringFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 418, col: 7, offset: 12093},
						name: "TypeCheckingFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 419, col: 7, offset: 12121},
						name: "ArrayFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 420, col: 7, offset: 12142},
						name: "InFunction",
					},
					&ruleRefExpr{
						pos:  position{line: 421, col: 7, offset: 12159},
						name: "AggregateFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 422, col: 7, offset: 12184},
						name: "MathFunctions",
					},
				},
			},
		},
		{
			name: "StringFunctions",
			pos:  position{line: 424, col: 1, offset: 12199},
			expr: &choiceExpr{
				pos: position{line: 424, col: 20, offset: 12218},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 424, col: 20, offset: 12218},
						name: "StringEqualsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 425, col: 7, offset: 12247},
						name: "ToStringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 426, col: 7, offset: 12272},
						name: "ConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 427, col: 7, offset: 12295},
						name: "ThreeArgumentStringFunctionExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 428, col: 7, offset: 12339},
						name: "UpperExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 429, col: 7, offset: 12361},
						name: "LowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 430, col: 7, offset: 12383},
						name: "LeftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 431, col: 7, offset: 12404},
						name: "LengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 432, col: 7, offset: 12427},
						name: "LTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 433, col: 7, offset: 12449},
						name: "ReplaceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 434, col: 7, offset: 12473},
						name: "ReplicateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 435, col: 7, offset: 12499},
						name: "ReverseExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 436, col: 7, offset: 12523},
						name: "RightExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 437, col: 7, offset: 12545},
						name: "RTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 438, col: 7, offset: 12567},
						name: "SubstringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 439, col: 7, offset: 12593},
						name: "TrimExpression",
					},
				},
			},
		},
		{
			name: "TypeCheckingFunctions",
			pos:  position{line: 441, col: 1, offset: 12609},
			expr: &choiceExpr{
				pos: position{line: 441, col: 26, offset: 12634},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 441, col: 26, offset: 12634},
						name: "IsDefined",
					},
					&ruleRefExpr{
						pos:  position{line: 442, col: 7, offset: 12650},
						name: "IsArray",
					},
					&ruleRefExpr{
						pos:  position{line: 443, col: 7, offset: 12664},
						name: "IsBool",
					},
					&ruleRefExpr{
						pos:  position{line: 444, col: 7, offset: 12677},
						name: "IsFiniteNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 445, col: 7, offset: 12698},
						name: "IsInteger",
					},
					&ruleRefExpr{
						pos:  position{line: 446, col: 7, offset: 12714},
						name: "IsNull",
					},
					&ruleRefExpr{
						pos:  position{line: 447, col: 7, offset: 12727},
						name: "IsNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 448, col: 7, offset: 12742},
						name: "IsObject",
					},
					&ruleRefExpr{
						pos:  position{line: 449, col: 7, offset: 12757},
						name: "IsPrimitive",
					},
					&ruleRefExpr{
						pos:  position{line: 450, col: 7, offset: 12775},
						name: "IsString",
					},
				},
			},
		},
		{
			name: "AggregateFunctions",
			pos:  position{line: 452, col: 1, offset: 12785},
			expr: &choiceExpr{
				pos: position{line: 452, col: 23, offset: 12807},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 452, col: 23, offset: 12807},
						name: "AvgAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 453, col: 7, offset: 12836},
						name: "CountAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 454, col: 7, offset: 12867},
						name: "MaxAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 455, col: 7, offset: 12896},
						name: "MinAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 456, col: 7, offset: 12925},
						name: "SumAggregateExpression",
					},
				},
			},
		},
		{
			name: "ArrayFunctions",
			pos:  position{line: 458, col: 1, offset: 12949},
			expr: &choiceExpr{
				pos: position{line: 458, col: 19, offset: 12967},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 458, col: 19, offset: 12967},
						name: "ArrayConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 459, col: 7, offset: 12995},
						name: "ArrayLengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 460, col: 7, offset: 13023},
						name: "ArraySliceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 461, col: 7, offset: 13050},
						name: "SetIntersectExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 462, col: 7, offset: 13079},
						name: "SetUnionExpression",
					},
				},
			},
		},
		{
			name: "MathFunctions",
			pos:  position{line: 464, col: 1, offset: 13099},
			expr: &choiceExpr{
				pos: position{line: 464, col: 18, offset: 13116},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 464, col: 18, offset: 13116},
						name: "MathAbsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 465, col: 7, offset: 13140},
						name: "MathAcosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 466, col: 7, offset: 13165},
						name: "MathAsinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 467, col: 7, offset: 13190},
						name: "MathAtanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 468, col: 7, offset: 13215},
						name: "MathCeilingExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 469, col: 7, offset: 13243},
						name: "MathCosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 470, col: 7, offset: 13267},
						name: "MathCotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 471, col: 7, offset: 13291},
						name: "MathDegreesExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 472, col: 7, offset: 13319},
						name: "MathExpExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 473, col: 7, offset: 13343},
						name: "MathFloorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 474, col: 7, offset: 13369},
						name: "MathIntBitNotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 475, col: 7, offset: 13399},
						name: "MathLog10Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 476, col: 7, offset: 13425},
						name: "MathRadiansExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 477, col: 7, offset: 13453},
						name: "MathRoundExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 478, col: 7, offset: 13479},
						name: "MathSignExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 479, col: 7, offset: 13504},
						name: "MathSinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 480, col: 7, offset: 13528},
						name: "MathSqrtExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 481, col: 7, offset: 13553},
						name: "MathSquareExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 482, col: 7, offset: 13580},
						name: "MathTanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 483, col: 7, offset: 13604},
						name: "MathTruncExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 484, col: 7, offset: 13630},
						name: "MathAtn2Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 485, col: 7, offset: 13655},
						name: "MathIntAddExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 486, col: 7, offset: 13682},
						name: "MathIntBitAndExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 487, col: 7, offset: 13712},
						name: "MathIntBitLeftShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 488, col: 7, offset: 13748},
						name: "MathIntBitOrExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 489, col: 7, offset: 13777},
						name: "MathIntBitRightShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 490, col: 7, offset: 13814},
						name: "MathIntBitXorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 491, col: 7, offset: 13844},
						name: "MathIntDivExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 492, col: 7, offset: 13871},
						name: "MathIntModExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 493, col: 7, offset: 13898},
						name: "MathIntMulExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 494, col: 7, offset: 13925},
						name: "MathIntSubExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 495, col: 7, offset: 13952},
						name: "MathPowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 496, col: 7, offset: 13978},
						name: "MathLogExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 497, col: 7, offset: 14002},
						name: "MathNumberBinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 498, col: 7, offset: 14032},
						name: "MathPiExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 499, col: 7, offset: 14055},
						name: "MathRandExpression",
					},
				},
			},
		},
		{
			name: "UpperExpression",
			pos:  position{line: 501, col: 1, offset: 14075},
			expr: &actionExpr{
				pos: position{line: 501, col: 20, offset: 14094},
				run: (*parser).callonUpperExpression1,
				expr: &seqExpr{
					pos: position{line: 501, col: 20, offset: 14094},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 501, col: 20, offset: 14094},
							val:        "upper",
							ignoreCase: true,
							want:       "\"UPPER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 501, col: 29, offset: 14103},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 501, col: 32, offset: 14106},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 501, col: 36, offset: 14110},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 501, col: 39, offset: 14113},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 501, col: 50, offset: 14124},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LowerExpression",
			pos:  position{line: 505, col: 1, offset: 14209},
			expr: &actionExpr{
				pos: position{line: 505, col: 20, offset: 14228},
				run: (*parser).callonLowerExpression1,
				expr: &seqExpr{
					pos: position{line: 505, col: 20, offset: 14228},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 505, col: 20, offset: 14228},
							val:        "lower",
							ignoreCase: true,
							want:       "\"LOWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 505, col: 29, offset: 14237},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 505, col: 32, offset: 14240},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 505, col: 36, offset: 14244},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 505, col: 39, offset: 14247},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 505, col: 50, offset: 14258},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "StringEqualsExpression",
			pos:  position{line: 509, col: 1, offset: 14343},
			expr: &actionExpr{
				pos: position{line: 509, col: 27, offset: 14369},
				run: (*parser).callonStringEqualsExpression1,
				expr: &seqExpr{
					pos: position{line: 509, col: 27, offset: 14369},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 509, col: 27, offset: 14369},
							val:        "stringequals",
							ignoreCase: true,
							want:       "\"STRINGEQUALS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 509, col: 43, offset: 14385},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 509, col: 46, offset: 14388},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 509, col: 50, offset: 14392},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 509, col: 53, offset: 14395},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 509, col: 57, offset: 14399},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 509, col: 68, offset: 14410},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 509, col: 71, offset: 14413},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 509, col: 75, offset: 14417},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 509, col: 78, offset: 14420},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 509, col: 82, offset: 14424},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 509, col: 93, offset: 14435},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 509, col: 96, offset: 14438},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 509, col: 107, offset: 14449},
								expr: &actionExpr{
									pos: position{line: 509, col: 108, offset: 14450},
									run: (*parser).callonStringEqualsExpression17,
									expr: &seqExpr{
										pos: position{line: 509, col: 108, offset: 14450},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 509, col: 108, offset: 14450},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 509, col: 112, offset: 14454},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 509, col: 115, offset: 14457},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 509, col: 123, offset: 14465},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 509, col: 160, offset: 14502},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ToStringExpression",
			pos:  position{line: 513, col: 1, offset: 14612},
			expr: &actionExpr{
				pos: position{line: 513, col: 23, offset: 14634},
				run: (*parser).callonToStringExpression1,
				expr: &seqExpr{
					pos: position{line: 513, col: 23, offset: 14634},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 513, col: 23, offset: 14634},
							val:        "tostring",
							ignoreCase: true,
							want:       "\"TOSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 513, col: 35, offset: 14646},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 513, col: 38, offset: 14649},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 513, col: 42, offset: 14653},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 513, col: 45, offset: 14656},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 513, col: 48, offset: 14659},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 513, col: 59, offset: 14670},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 513, col: 62, offset: 14673},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ConcatExpression",
			pos:  position{line: 517, col: 1, offset: 14761},
			expr: &actionExpr{
				pos: position{line: 517, col: 21, offset: 14781},
				run: (*parser).callonConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 517, col: 21, offset: 14781},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 517, col: 21, offset: 14781},
							val:        "concat",
							ignoreCase: true,
							want:       "\"CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 517, col: 31, offset: 14791},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 517, col: 34, offset: 14794},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 517, col: 38, offset: 14798},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 517, col: 41, offset: 14801},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 517, col: 45, offset: 14805},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 517, col: 56, offset: 14816},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 517, col: 63, offset: 14823},
								expr: &actionExpr{
									pos: position{line: 517, col: 64, offset: 14824},
									run: (*parser).callonConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 517, col: 64, offset: 14824},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 517, col: 64, offset: 14824},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 517, col: 67, offset: 14827},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 517, col: 71, offset: 14831},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 517, col: 74, offset: 14834},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 517, col: 77, offset: 14837},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 517, col: 109, offset: 14869},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 517, col: 112, offset: 14872},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LeftExpression",
			pos:  position{line: 522, col: 1, offset: 15021},
			expr: &actionExpr{
				pos: position{line: 522, col: 19, offset: 15039},
				run: (*parser).callonLeftExpression1,
				expr: &seqExpr{
					pos: position{line: 522, col: 19, offset: 15039},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 522, col: 19, offset: 15039},
							val:        "left",
							ignoreCase: true,
							want:       "\"LEFT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 522, col: 27, offset: 15047},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 522, col: 30, offset: 15050},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 522, col: 34, offset: 15054},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 522, col: 37, offset: 15057},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 522, col: 40, offset: 15060},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 522, col: 51, offset: 15071},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 522, col: 54, offset: 15074},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 522, col: 58, offset: 15078},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 522, col: 61, offset: 15081},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 522, col: 68, offset: 15088},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 522, col: 79, offset: 15099},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 522, col: 82, offset: 15102},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LengthExpression",
			pos:  position{line: 526, col: 1, offset: 15194},
			expr: &actionExpr{
				pos: position{line: 526, col: 21, offset: 15214},
				run: (*parser).callonLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 526, col: 21, offset: 15214},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 526, col: 21, offset: 15214},
							val:        "length",
							ignoreCase: true,
							want:       "\"LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 526, col: 31, offset: 15224},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 526, col: 34, offset: 15227},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 526, col: 38, offset: 15231},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 526, col: 41, offset: 15234},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 526, col: 44, offset: 15237},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 526, col: 55, offset: 15248},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 526, col: 58, offset: 15251},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LTrimExpression",
			pos:  position{line: 530, col: 1, offset: 15337},
			expr: &actionExpr{
				pos: position{line: 530, col: 20, offset: 15356},
				run: (*parser).callonLTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 530, col: 20, offset: 15356},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 530, col: 20, offset: 15356},
							val:        "ltrim",
							ignoreCase: true,
							want:       "\"LTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 530, col: 29, offset: 15365},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 530, col: 32, offset: 15368},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 530, col: 36, offset: 15372},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 530, col: 39, offset: 15375},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 530, col: 42, offset: 15378},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 530, col: 53, offset: 15389},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 530, col: 56, offset: 15392},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplaceExpression",
			pos:  position{line: 534, col: 1, offset: 15477},
			expr: &actionExpr{
				pos: position{line: 534, col: 22, offset: 15498},
				run: (*parser).callonReplaceExpression1,
				expr: &seqExpr{
					pos: position{line: 534, col: 22, offset: 15498},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 534, col: 22, offset: 15498},
							val:        "replace",
							ignoreCase: true,
							want:       "\"REPLACE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 534, col: 33, offset: 15509},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 534, col: 36, offset: 15512},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 534, col: 40, offset: 15516},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 534, col: 43, offset: 15519},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 534, col: 47, offset: 15523},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 534, col: 58, offset: 15534},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 534, col: 61, offset: 15537},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 534, col: 65, offset: 15541},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 534, col: 68, offset: 15544},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 534, col: 72, offset: 15548},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 534, col: 83, offset: 15559},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 534, col: 86, offset: 15562},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 534, col: 90, offset: 15566},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 534, col: 93, offset: 15569},
							label: "ex3",
							expr: &ruleRefExpr{
								pos:  position{line: 534, col: 97, offset: 15573},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 534, col: 108, offset: 15584},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 534, col: 111, offset: 15587},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplicateExpression",
			pos:  position{line: 538, col: 1, offset: 15685},
			expr: &actionExpr{
				pos: position{line: 538, col: 24, offset: 15708},
				run: (*parser).callonReplicateExpression1,
				expr: &seqExpr{
					pos: position{line: 538, col: 24, offset: 15708},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 538, col: 24, offset: 15708},
							val:        "replicate",
							ignoreCase: true,
							want:       "\"REPLICATE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 538, col: 37, offset: 15721},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 538, col: 40, offset: 15724},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 538, col: 44, offset: 15728},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 538, col: 47, offset: 15731},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 538, col: 51, offset: 15735},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 538, col: 62, offset: 15746},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 538, col: 65, offset: 15749},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 538, col: 69, offset: 15753},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 538, col: 72, offset: 15756},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 538, col: 76, offset: 15760},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 538, col: 87, offset: 15771},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 538, col: 90, offset: 15774},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReverseExpression",
			pos:  position{line: 542, col: 1, offset: 15869},
			expr: &actionExpr{
				pos: position{line: 542, col: 22, offset: 15890},
				run: (*parser).callonReverseExpression1,
				expr: &seqExpr{
					pos: position{line: 542, col: 22, offset: 15890},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 542, col: 22, offset: 15890},
							val:        "reverse",
							ignoreCase: true,
							want:       "\"REVERSE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 542, col: 33, offset: 15901},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 542, col: 36, offset: 15904},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 542, col: 40, offset: 15908},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 542, col: 43, offset: 15911},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 542, col: 46, offset: 15914},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 542, col: 57, offset: 15925},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 542, col: 60, offset: 15928},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RightExpression",
			pos:  position{line: 546, col: 1, offset: 16015},
			expr: &actionExpr{
				pos: position{line: 546, col: 20, offset: 16034},
				run: (*parser).callonRightExpression1,
				expr: &seqExpr{
					pos: position{line: 546, col: 20, offset: 16034},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 546, col: 20, offset: 16034},
							val:        "right",
							ignoreCase: true,
							want:       "\"RIGHT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 546, col: 29, offset: 16043},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 546, col: 32, offset: 16046},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 546, col: 36, offset: 16050},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 546, col: 39, offset: 16053},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 546, col: 42, offset: 16056},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 546, col: 53, offset: 16067},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 546, col: 56, offset: 16070},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 546, col: 60, offset: 16074},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 546, col: 63, offset: 16077},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 546, col: 70, offset: 16084},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 546, col: 81, offset: 16095},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 546, col: 84, offset: 16098},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RTrimExpression",
			pos:  position{line: 550, col: 1, offset: 16191},
			expr: &actionExpr{
				pos: position{line: 550, col: 20, offset: 16210},
				run: (*parser).callonRTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 550, col: 20, offset: 16210},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 550, col: 20, offset: 16210},
							val:        "rtrim",
							ignoreCase: true,
							want:       "\"RTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 550, col: 29, offset: 16219},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 550, col: 32, offset: 16222},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 550, col: 36, offset: 16226},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 550, col: 39, offset: 16229},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 550, col: 42, offset: 16232},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 550, col: 53, offset: 16243},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 550, col: 56, offset: 16246},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubstringExpression",
			pos:  position{line: 554, col: 1, offset: 16331},
			expr: &actionExpr{
				pos: position{line: 554, col: 24, offset: 16354},
				run: (*parser).callonSubstringExpression1,
				expr: &seqExpr{
					pos: position{line: 554, col: 24, offset: 16354},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 554, col: 24, offset: 16354},
							val:        "substring",
							ignoreCase: true,
							want:       "\"SUBSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 37, offset: 16367},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 554, col: 40, offset: 16370},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 44, offset: 16374},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 554, col: 47, offset: 16377},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 554, col: 50, offset: 16380},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 61, offset: 16391},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 554, col: 64, offset: 16394},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 68, offset: 16398},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 554, col: 71, offset: 16401},
							label: "startPos",
							expr: &ruleRefExpr{
								pos:  position{line: 554, col: 80, offset: 16410},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 91, offset: 16421},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 554, col: 94, offset: 16424},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 98, offset: 16428},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 554, col: 101, offset: 16431},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 554, col: 108, offset: 16438},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 119, offset: 16449},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 554, col: 122, offset: 16452},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "TrimExpression",
			pos:  position{line: 558, col: 1, offset: 16559},
			expr: &actionExpr{
				pos: position{line: 558, col: 19, offset: 16577},
				run: (*parser).callonTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 558, col: 19, offset: 16577},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 558, col: 19, offset: 16577},
							val:        "trim",
							ignoreCase: true,
							want:       "\"TRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 27, offset: 16585},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 558, col: 30, offset: 16588},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 34, offset: 16592},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 558, col: 37, offset: 16595},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 558, col: 40, offset: 16598},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 51, offset: 16609},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 558, col: 54, offset: 16612},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunctionExpression",
			pos:  position{line: 562, col: 1, offset: 16696},
			expr: &actionExpr{
				pos: position{line: 562, col: 42, offset: 16737},
				run: (*parser).callonThreeArgumentStringFunctionExpression1,
				expr: &seqExpr{
					pos: position{line: 562, col: 42, offset: 16737},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 562, col: 42, offset: 16737},
							label: "function",
							expr: &ruleRefExpr{
								pos:  position{line: 562, col: 51, offset: 16746},
								name: "ThreeArgumentStringFunction",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 79, offset: 16774},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 562, col: 82, offset: 16777},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 86, offset: 16781},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 562, col: 89, offset: 16784},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 562, col: 93, offset: 16788},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 104, offset: 16799},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 562, col: 107, offset: 16802},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 111, offset: 16806},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 562, col: 114, offset: 16809},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 562, col: 118, offset: 16813},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 129, offset: 16824},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 562, col: 132, offset: 16827},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 562, col: 143, offset: 16838},
								expr: &actionExpr{
									pos: position{line: 562, col: 144, offset: 16839},
									run: (*parser).callonThreeArgumentStringFunctionExpression18,
									expr: &seqExpr{
										pos: position{line: 562, col: 144, offset: 16839},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 562, col: 144, offset: 16839},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 562, col: 148, offset: 16843},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 562, col: 151, offset: 16846},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 562, col: 159, offset: 16854},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 562, col: 196, offset: 16891},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunction",
			pos:  position{line: 580, col: 1, offset: 17413},
			expr: &actionExpr{
				pos: position{line: 580, col: 32, offset: 17444},
				run: (*parser).callonThreeArgumentStringFunction1,
				expr: &choiceExpr{
					pos: position{line: 580, col: 33, offset: 17445},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 580, col: 33, offset: 17445},
							val:        "contains",
							ignoreCase: true,
							want:       "\"CONTAINS\"i",
						},
						&litMatcher{
							pos:        position{line: 580, col: 47, offset: 17459},
							val:        "endswith",
							ignoreCase: true,
							want:       "\"ENDSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 580, col: 61, offset: 17473},
							val:        "startswith",
							ignoreCase: true,
							want:       "\"STARTSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 580, col: 77, offset: 17489},
							val:        "index_of",
							ignoreCase: true,
							want:       "\"INDEX_OF\"i",
						},
					},
				},
			},
		},
		{
			name: "IsDefined",
			pos:  position{line: 584, col: 1, offset: 17538},
			expr: &actionExpr{
				pos: position{line: 584, col: 14, offset: 17551},
				run: (*parser).callonIsDefined1,
				expr: &seqExpr{
					pos: position{line: 584, col: 14, offset: 17551},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 584, col: 14, offset: 17551},
							val:        "is_defined",
							ignoreCase: true,
							want:       "\"IS_DEFINED\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 584, col: 28, offset: 17565},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 584, col: 31, offset: 17568},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 584, col: 35, offset: 17572},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 584, col: 38, offset: 17575},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 584, col: 41, offset: 17578},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 584, col: 52, offset: 17589},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 584, col: 55, offset: 17592},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsArray",
			pos:  position{line: 588, col: 1, offset: 17681},
			expr: &actionExpr{
				pos: position{line: 588, col: 12, offset: 17692},
				run: (*parser).callonIsArray1,
				expr: &seqExpr{
					pos: position{line: 588, col: 12, offset: 17692},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 588, col: 12, offset: 17692},
							val:        "is_array",
							ignoreCase: true,
							want:       "\"IS_ARRAY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 588, col: 24, offset: 17704},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 588, col: 27, offset: 17707},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 588, col: 31, offset: 17711},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 588, col: 34, offset: 17714},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 588, col: 37, offset: 17717},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 588, col: 48, offset: 17728},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 588, col: 51, offset: 17731},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsBool",
			pos:  position{line: 592, col: 1, offset: 17818},
			expr: &actionExpr{
				pos: position{line: 592, col: 11, offset: 17828},
				run: (*parser).callonIsBool1,
				expr: &seqExpr{
					pos: position{line: 592, col: 11, offset: 17828},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 592, col: 11, offset: 17828},
							val:        "is_bool",
							ignoreCase: true,
							want:       "\"IS_BOOL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 592, col: 22, offset: 17839},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 592, col: 25, offset: 17842},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 592, col: 29, offset: 17846},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 592, col: 32, offset: 17849},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 592, col: 35, offset: 17852},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 592, col: 46, offset: 17863},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 592, col: 49, offset: 17866},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsFiniteNumber",
			pos:  position{line: 596, col: 1, offset: 17952},
			expr: &actionExpr{
				pos: position{line: 596, col: 19, offset: 17970},
				run: (*parser).callonIsFiniteNumber1,
				expr: &seqExpr{
					pos: position{line: 596, col: 19, offset: 17970},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 596, col: 19, offset: 17970},
							val:        "is_finite_number",
							ignoreCase: true,
							want:       "\"IS_FINITE_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 596, col: 39, offset: 17990},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 596, col: 42, offset: 17993},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 596, col: 46, offset: 17997},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 596, col: 49, offset: 18000},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 596, col: 52, offset: 18003},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 596, col: 63, offset: 18014},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 596, col: 66, offset: 18017},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsInteger",
			pos:  position{line: 600, col: 1, offset: 18111},
			expr: &actionExpr{
				pos: position{line: 600, col: 14, offset: 18124},
				run: (*parser).callonIsInteger1,
				expr: &seqExpr{
					pos: position{line: 600, col: 14, offset: 18124},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 600, col: 14, offset: 18124},
							val:        "is_integer",
							ignoreCase: true,
							want:       "\"IS_INTEGER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 600, col: 28, offset: 18138},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 600, col: 31, offset: 18141},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 600, col: 35, offset: 18145},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 600, col: 38, offset: 18148},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 600, col: 41, offset: 18151},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 600, col: 52, offset: 18162},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 600, col: 55, offset: 18165},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNull",
			pos:  position{line: 604, col: 1, offset: 18254},
			expr: &actionExpr{
				pos: position{line: 604, col: 11, offset: 18264},
				run: (*parser).callonIsNull1,
				expr: &seqExpr{
					pos: position{line: 604, col: 11, offset: 18264},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 604, col: 11, offset: 18264},
							val:        "is_null",
							ignoreCase: true,
							want:       "\"IS_NULL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 604, col: 22, offset: 18275},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 604, col: 25, offset: 18278},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 604, col: 29, offset: 18282},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 604, col: 32, offset: 18285},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 604, col: 35, offset: 18288},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 604, col: 46, offset: 18299},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 604, col: 49, offset: 18302},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNumber",
			pos:  position{line: 608, col: 1, offset: 18388},
			expr: &actionExpr{
				pos: position{line: 608, col: 13, offset: 18400},
				run: (*parser).callonIsNumber1,
				expr: &seqExpr{
					pos: position{line: 608, col: 13, offset: 18400},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 608, col: 13, offset: 18400},
							val:        "is_number",
							ignoreCase: true,
							want:       "\"IS_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 608, col: 26, offset: 18413},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 608, col: 29, offset: 18416},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 608, col: 33, offset: 18420},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 608, col: 36, offset: 18423},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 608, col: 39, offset: 18426},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 608, col: 50, offset: 18437},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 608, col: 53, offset: 18440},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsObject",
			pos:  position{line: 612, col: 1, offset: 18528},
			expr: &actionExpr{
				pos: position{line: 612, col: 13, offset: 18540},
				run: (*parser).callonIsObject1,
				expr: &seqExpr{
					pos: position{line: 612, col: 13, offset: 18540},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 612, col: 13, offset: 18540},
							val:        "is_object",
							ignoreCase: true,
							want:       "\"IS_OBJECT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 612, col: 26, offset: 18553},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 612, col: 29, offset: 18556},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 612, col: 33, offset: 18560},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 612, col: 36, offset: 18563},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 612, col: 39, offset: 18566},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 612, col: 50, offset: 18577},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 612, col: 53, offset: 18580},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsPrimitive",
			pos:  position{line: 616, col: 1, offset: 18668},
			expr: &actionExpr{
				pos: position{line: 616, col: 16, offset: 18683},
				run: (*parser).callonIsPrimitive1,
				expr: &seqExpr{
					pos: position{line: 616, col: 16, offset: 18683},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 616, col: 16, offset: 18683},
							val:        "is_primitive",
							ignoreCase: true,
							want:       "\"IS_PRIMITIVE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 616, col: 32, offset: 18699},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 616, col: 35, offset: 18702},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 616, col: 39, offset: 18706},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 616, col: 42, offset: 18709},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 616, col: 45, offset: 18712},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 616, col: 56, offset: 18723},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 616, col: 59, offset: 18726},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsString",
			pos:  position{line: 620, col: 1, offset: 18817},
			expr: &actionExpr{
				pos: position{line: 620, col: 13, offset: 18829},
				run: (*parser).callonIsString1,
				expr: &seqExpr{
					pos: position{line: 620, col: 13, offset: 18829},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 620, col: 13, offset: 18829},
							val:        "is_string",
							ignoreCase: true,
							want:       "\"IS_STRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 620, col: 26, offset: 18842},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 620, col: 29, offset: 18845},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 620, col: 33, offset: 18849},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 620, col: 36, offset: 18852},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 620, col: 39, offset: 18855},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 620, col: 50, offset: 18866},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 620, col: 53, offset: 18869},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayConcatExpression",
			pos:  position{line: 624, col: 1, offset: 18957},
			expr: &actionExpr{
				pos: position{line: 624, col: 26, offset: 18982},
				run: (*parser).callonArrayConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 624, col: 26, offset: 18982},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 624, col: 26, offset: 18982},
							val:        "array_concat",
							ignoreCase: true,
							want:       "\"ARRAY_CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 624, col: 42, offset: 18998},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 624, col: 45, offset: 19001},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 624, col: 49, offset: 19005},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 624, col: 52, offset: 19008},
							label: "arrays",
							expr: &ruleRefExpr{
								pos:  position{line: 624, col: 59, offset: 19015},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 624, col: 70, offset: 19026},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 624, col: 77, offset: 19033},
								expr: &actionExpr{
									pos: position{line: 624, col: 78, offset: 19034},
									run: (*parser).callonArrayConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 624, col: 78, offset: 19034},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 624, col: 78, offset: 19034},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 624, col: 81, offset: 19037},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 624, col: 85, offset: 19041},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 624, col: 88, offset: 19044},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 624, col: 91, offset: 19047},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 624, col: 123, offset: 19079},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 624, col: 126, offset: 19082},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayLengthExpression",
			pos:  position{line: 628, col: 1, offset: 19212},
			expr: &actionExpr{
				pos: position{line: 628, col: 26, offset: 19237},
				run: (*parser).callonArrayLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 628, col: 26, offset: 19237},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 628, col: 26, offset: 19237},
							val:        "array_length",
							ignoreCase: true,
							want:       "\"ARRAY_LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 628, col: 42, offset: 19253},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 628, col: 45, offset: 19256},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 628, col: 49, offset: 19260},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 628, col: 52, offset: 19263},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 628, col: 58, offset: 19269},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 628, col: 69, offset: 19280},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 628, col: 72, offset: 19283},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArraySliceExpression",
			pos:  position{line: 632, col: 1, offset: 19377},
			expr: &actionExpr{
				pos: position{line: 632, col: 25, offset: 19401},
				run: (*parser).callonArraySliceExpression1,
				expr: &seqExpr{
					pos: position{line: 632, col: 25, offset: 19401},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 632, col: 25, offset: 19401},
							val:        "array_slice",
							ignoreCase: true,
							want:       "\"ARRAY_SLICE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 40, offset: 19416},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 632, col: 43, offset: 19419},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 47, offset: 19423},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 632, col: 50, offset: 19426},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 632, col: 56, offset: 19432},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 67, offset: 19443},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 632, col: 70, offset: 19446},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 74, offset: 19450},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 632, col: 77, offset: 19453},
							label: "start",
							expr: &ruleRefExpr{
								pos:  position{line: 632, col: 83, offset: 19459},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 632, col: 94, offset: 19470},
							label: "length",
							expr: &zeroOrOneExpr{
								pos: position{line: 632, col: 101, offset: 19477},
								expr: &actionExpr{
									pos: position{line: 632, col: 102, offset: 19478},
									run: (*parser).callonArraySliceExpression16,
									expr: &seqExpr{
										pos: position{line: 632, col: 102, offset: 19478},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 632, col: 102, offset: 19478},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 632, col: 105, offset: 19481},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 632, col: 109, offset: 19485},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 632, col: 112, offset: 19488},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 632, col: 115, offset: 19491},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 147, offset: 19523},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 632, col: 150, offset: 19526},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetIntersectExpression",
			pos:  position{line: 636, col: 1, offset: 19634},
			expr: &actionExpr{
				pos: position{line: 636, col: 27, offset: 19660},
				run: (*parser).callonSetIntersectExpression1,
				expr: &seqExpr{
					pos: position{line: 636, col: 27, offset: 19660},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 636, col: 27, offset: 19660},
							val:        "setintersect",
							ignoreCase: true,
							want:       "\"SetIntersect\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 43, offset: 19676},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 636, col: 46, offset: 19679},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 50, offset: 19683},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 636, col: 53, offset: 19686},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 636, col: 58, offset: 19691},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 69, offset: 19702},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 636, col: 72, offset: 19705},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 76, offset: 19709},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 636, col: 79, offset: 19712},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 636, col: 84, offset: 19717},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 95, offset: 19728},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 636, col: 98, offset: 19731},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetUnionExpression",
			pos:  position{line: 640, col: 1, offset: 19831},
			expr: &actionExpr{
				pos: position{line: 640, col: 23, offset: 19853},
				run: (*parser).callonSetUnionExpression1,
				expr: &seqExpr{
					pos: position{line: 640, col: 23, offset: 19853},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 640, col: 23, offset: 19853},
							val:        "setunion",
							ignoreCase: true,
							want:       "\"SetUnion\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 35, offset: 19865},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 640, col: 38, offset: 19868},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 42, offset: 19872},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 640, col: 45, offset: 19875},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 640, col: 50, offset: 19880},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 61, offset: 19891},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 640, col: 64, offset: 19894},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 68, offset: 19898},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 640, col: 71, offset: 19901},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 640, col: 76, offset: 19906},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 87, offset: 19917},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 640, col: 90, offset: 19920},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAbsExpression",
			pos:  position{line: 644, col: 1, offset: 20016},
			expr: &actionExpr{
				pos: position{line: 644, col: 22, offset: 20037},
				run: (*parser).callonMathAbsExpression1,
				expr: &seqExpr{
					pos: position{line: 644, col: 22, offset: 20037},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 644, col: 22, offset: 20037},
							val:        "abs",
							ignoreCase: true,
							want:       "\"ABS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 644, col: 29, offset: 20044},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 644, col: 32, offset: 20047},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 644, col: 36, offset: 20051},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 644, col: 39, offset: 20054},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 644, col: 42, offset: 20057},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 644, col: 53, offset: 20068},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 644, col: 56, offset: 20071},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAcosExpression",
			pos:  position{line: 645, col: 1, offset: 20153},
			expr: &actionExpr{
				pos: position{line: 645, col: 23, offset: 20175},
				run: (*parser).callonMathAcosExpression1,
				expr: &seqExpr{
					pos: position{line: 645, col: 23, offset: 20175},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 645, col: 23, offset: 20175},
							val:        "acos",
							ignoreCase: true,
							want:       "\"ACOS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 645, col: 31, offset: 20183},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 645, col: 34, offset: 20186},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 645, col: 38, offset: 20190},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 645, col: 41, offset: 20193},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 645, col: 44, offset: 20196},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 645, col: 55, offset: 20207},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 645, col: 58, offset: 20210},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAsinExpression",
			pos:  position{line: 646, col: 1, offset: 20293},
			expr: &actionExpr{
				pos: position{line: 646, col: 23, offset: 20315},
				run: (*parser).callonMathAsinExpression1,
				expr: &seqExpr{
					pos: position{line: 646, col: 23, offset: 20315},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 646, col: 23, offset: 20315},
							val:        "asin",
							ignoreCase: true,
							want:       "\"ASIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 646, col: 31, offset: 20323},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 646, col: 34, offset: 20326},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 646, col: 38, offset: 20330},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 646, col: 41, offset: 20333},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 646, col: 44, offset: 20336},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 646, col: 55, offset: 20347},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 646, col: 58, offset: 20350},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtanExpression",
			pos:  position{line: 647, col: 1, offset: 20433},
			expr: &actionExpr{
				pos: position{line: 647, col: 23, offset: 20455},
				run: (*parser).callonMathAtanExpression1,
				expr: &seqExpr{
					pos: position{line: 647, col: 23, offset: 20455},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 647, col: 23, offset: 20455},
							val:        "atan",
							ignoreCase: true,
							want:       "\"ATAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 647, col: 31, offset: 20463},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 647, col: 34, offset: 20466},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 647, col: 38, offset: 20470},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 647, col: 41, offset: 20473},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 647, col: 44, offset: 20476},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 647, col: 55, offset: 20487},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 647, col: 58, offset: 20490},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCeilingExpression",
			pos:  position{line: 648, col: 1, offset: 20573},
			expr: &actionExpr{
				pos: position{line: 648, col: 26, offset: 20598},
				run: (*parser).callonMathCeilingExpression1,
				expr: &seqExpr{
					pos: position{line: 648, col: 26, offset: 20598},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 648, col: 26, offset: 20598},
							val:        "ceiling",
							ignoreCase: true,
							want:       "\"CEILING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 648, col: 37, offset: 20609},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 648, col: 40, offset: 20612},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 648, col: 44, offset: 20616},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 648, col: 47, offset: 20619},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 648, col: 50, offset: 20622},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 648, col: 61, offset: 20633},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 648, col: 64, offset: 20636},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCosExpression",
			pos:  position{line: 649, col: 1, offset: 20722},
			expr: &actionExpr{
				pos: position{line: 649, col: 22, offset: 20743},
				run: (*parser).callonMathCosExpression1,
				expr: &seqExpr{
					pos: position{line: 649, col: 22, offset: 20743},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 649, col: 22, offset: 20743},
							val:        "cos",
							ignoreCase: true,
							want:       "\"COS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 649, col: 29, offset: 20750},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 649, col: 32, offset: 20753},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 649, col: 36, offset: 20757},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 649, col: 39, offset: 20760},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 649, col: 42, offset: 20763},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 649, col: 53, offset: 20774},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 649, col: 56, offset: 20777},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCotExpression",
			pos:  position{line: 650, col: 1, offset: 20859},
			expr: &actionExpr{
				pos: position{line: 650, col: 22, offset: 20880},
				run: (*parser).callonMathCotExpression1,
				expr: &seqExpr{
					pos: position{line: 650, col: 22, offset: 20880},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 650, col: 22, offset: 20880},
							val:        "cot",
							ignoreCase: true,
							want:       "\"COT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 650, col: 29, offset: 20887},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 650, col: 32, offset: 20890},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 650, col: 36, offset: 20894},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 650, col: 39, offset: 20897},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 650, col: 42, offset: 20900},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 650, col: 53, offset: 20911},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 650, col: 56, offset: 20914},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathDegreesExpression",
			pos:  position{line: 651, col: 1, offset: 20996},
			expr: &actionExpr{
				pos: position{line: 651, col: 26, offset: 21021},
				run: (*parser).callonMathDegreesExpression1,
				expr: &seqExpr{
					pos: position{line: 651, col: 26, offset: 21021},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 651, col: 26, offset: 21021},
							val:        "degrees",
							ignoreCase: true,
							want:       "\"DEGREES\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 651, col: 37, offset: 21032},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 651, col: 40, offset: 21035},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 651, col: 44, offset: 21039},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 651, col: 47, offset: 21042},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 651, col: 50, offset: 21045},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 651, col: 61, offset: 21056},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 651, col: 64, offset: 21059},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathExpExpression",
			pos:  position{line: 652, col: 1, offset: 21145},
			expr: &actionExpr{
				pos: position{line: 652, col: 22, offset: 21166},
				run: (*parser).callonMathExpExpression1,
				expr: &seqExpr{
					pos: position{line: 652, col: 22, offset: 21166},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 652, col: 22, offset: 21166},
							val:        "exp",
							ignoreCase: true,
							want:       "\"EXP\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 652, col: 29, offset: 21173},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 652, col: 32, offset: 21176},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 652, col: 36, offset: 21180},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 652, col: 39, offset: 21183},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 652, col: 42, offset: 21186},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 652, col: 53, offset: 21197},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 652, col: 56, offset: 21200},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathFloorExpression",
			pos:  position{line: 653, col: 1, offset: 21282},
			expr: &actionExpr{
				pos: position{line: 653, col: 24, offset: 21305},
				run: (*parser).callonMathFloorExpression1,
				expr: &seqExpr{
					pos: position{line: 653, col: 24, offset: 21305},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 653, col: 24, offset: 21305},
							val:        "floor",
							ignoreCase: true,
							want:       "\"FLOOR\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 653, col: 33, offset: 21314},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 653, col: 36, offset: 21317},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 653, col: 40, offset: 21321},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 653, col: 43, offset: 21324},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 653, col: 46, offset: 21327},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 653, col: 57, offset: 21338},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 653, col: 60, offset: 21341},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitNotExpression",
			pos:  position{line: 654, col: 1, offset: 21425},
			expr: &actionExpr{
				pos: position{line: 654, col: 28, offset: 21452},
				run: (*parser).callonMathIntBitNotExpression1,
				expr: &seqExpr{
					pos: position{line: 654, col: 28, offset: 21452},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 654, col: 28, offset: 21452},
							val:        "intbitnot",
							ignoreCase: true,
							want:       "\"IntBitNot\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 654, col: 41, offset: 21465},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 654, col: 44, offset: 21468},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 654, col: 48, offset: 21472},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 654, col: 51, offset: 21475},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 654, col: 54, offset: 21478},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 654, col: 65, offset: 21489},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 654, col: 68, offset: 21492},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLog10Expression",
			pos:  position{line: 655, col: 1, offset: 21580},
			expr: &actionExpr{
				pos: position{line: 655, col: 24, offset: 21603},
				run: (*parser).callonMathLog10Expression1,
				expr: &seqExpr{
					pos: position{line: 655, col: 24, offset: 21603},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 655, col: 24, offset: 21603},
							val:        "log10",
							ignoreCase: true,
							want:       "\"LOG10\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 655, col: 33, offset: 21612},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 655, col: 36, offset: 21615},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 655, col: 40, offset: 21619},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 655, col: 43, offset: 21622},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 655, col: 46, offset: 21625},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 655, col: 57, offset: 21636},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 655, col: 60, offset: 21639},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRadiansExpression",
			pos:  position{line: 656, col: 1, offset: 21723},
			expr: &actionExpr{
				pos: position{line: 656, col: 26, offset: 21748},
				run: (*parser).callonMathRadiansExpression1,
				expr: &seqExpr{
					pos: position{line: 656, col: 26, offset: 21748},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 656, col: 26, offset: 21748},
							val:        "radians",
							ignoreCase: true,
							want:       "\"RADIANS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 37, offset: 21759},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 656, col: 40, offset: 21762},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 44, offset: 21766},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 656, col: 47, offset: 21769},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 656, col: 50, offset: 21772},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 61, offset: 21783},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 656, col: 64, offset: 21786},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRoundExpression",
			pos:  position{line: 657, col: 1, offset: 21872},
			expr: &actionExpr{
				pos: position{line: 657, col: 24, offset: 21895},
				run: (*parser).callonMathRoundExpression1,
				expr: &seqExpr{
					pos: position{line: 657, col: 24, offset: 21895},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 657, col: 24, offset: 21895},
							val:        "round",
							ignoreCase: true,
							want:       "\"ROUND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 657, col: 33, offset: 21904},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 657, col: 36, offset: 21907},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 657, col: 40, offset: 21911},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 657, col: 43, offset: 21914},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 657, col: 46, offset: 21917},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 657, col: 57, offset: 21928},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 657, col: 60, offset: 21931},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSignExpression",
			pos:  position{line: 658, col: 1, offset: 22015},
			expr: &actionExpr{
				pos: position{line: 658, col: 23, offset: 22037},
				run: (*parser).callonMathSignExpression1,
				expr: &seqExpr{
					pos: position{line: 658, col: 23, offset: 22037},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 658, col: 23, offset: 22037},
							val:        "sign",
							ignoreCase: true,
							want:       "\"SIGN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 658, col: 31, offset: 22045},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 658, col: 34, offset: 22048},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 658, col: 38, offset: 22052},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 658, col: 41, offset: 22055},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 658, col: 44, offset: 22058},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 658, col: 55, offset: 22069},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 658, col: 58, offset: 22072},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSinExpression",
			pos:  position{line: 659, col: 1, offset: 22155},
			expr: &actionExpr{
				pos: position{line: 659, col: 22, offset: 22176},
				run: (*parser).callonMathSinExpression1,
				expr: &seqExpr{
					pos: position{line: 659, col: 22, offset: 22176},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 659, col: 22, offset: 22176},
							val:        "sin",
							ignoreCase: true,
							want:       "\"SIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 659, col: 29, offset: 22183},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 659, col: 32, offset: 22186},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 659, col: 36, offset: 22190},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 659, col: 39, offset: 22193},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 659, col: 42, offset: 22196},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 659, col: 53, offset: 22207},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 659, col: 56, offset: 22210},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSqrtExpression",
			pos:  position{line: 660, col: 1, offset: 22292},
			expr: &actionExpr{
				pos: position{line: 660, col: 23, offset: 22314},
				run: (*parser).callonMathSqrtExpression1,
				expr: &seqExpr{
					pos: position{line: 660, col: 23, offset: 22314},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 660, col: 23, offset: 22314},
							val:        "sqrt",
							ignoreCase: true,
							want:       "\"SQRT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 660, col: 31, offset: 22322},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 660, col: 34, offset: 22325},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 660, col: 38, offset: 22329},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 660, col: 41, offset: 22332},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 660, col: 44, offset: 22335},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 660, col: 55, offset: 22346},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 660, col: 58, offset: 22349},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSquareExpression",
			pos:  position{line: 661, col: 1, offset: 22432},
			expr: &actionExpr{
				pos: position{line: 661, col: 25, offset: 22456},
				run: (*parser).callonMathSquareExpression1,
				expr: &seqExpr{
					pos: position{line: 661, col: 25, offset: 22456},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 661, col: 25, offset: 22456},
							val:        "square",
							ignoreCase: true,
							want:       "\"SQUARE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 661, col: 35, offset: 22466},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 661, col: 38, offset: 22469},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 661, col: 42, offset: 22473},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 661, col: 45, offset: 22476},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 661, col: 48, offset: 22479},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 661, col: 59, offset: 22490},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 661, col: 62, offset: 22493},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTanExpression",
			pos:  position{line: 662, col: 1, offset: 22578},
			expr: &actionExpr{
				pos: position{line: 662, col: 22, offset: 22599},
				run: (*parser).callonMathTanExpression1,
				expr: &seqExpr{
					pos: position{line: 662, col: 22, offset: 22599},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 662, col: 22, offset: 22599},
							val:        "tan",
							ignoreCase: true,
							want:       "\"TAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 662, col: 29, offset: 22606},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 662, col: 32, offset: 22609},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 662, col: 36, offset: 22613},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 662, col: 39, offset: 22616},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 662, col: 42, offset: 22619},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 662, col: 53, offset: 22630},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 662, col: 56, offset: 22633},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTruncExpression",
			pos:  position{line: 663, col: 1, offset: 22715},
			expr: &actionExpr{
				pos: position{line: 663, col: 24, offset: 22738},
				run: (*parser).callonMathTruncExpression1,
				expr: &seqExpr{
					pos: position{line: 663, col: 24, offset: 22738},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 663, col: 24, offset: 22738},
							val:        "trunc",
							ignoreCase: true,
							want:       "\"TRUNC\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 663, col: 33, offset: 22747},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 663, col: 36, offset: 22750},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 663, col: 40, offset: 22754},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 663, col: 43, offset: 22757},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 663, col: 46, offset: 22760},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 663, col: 57, offset: 22771},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 663, col: 60, offset: 22774},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtn2Expression",
			pos:  position{line: 665, col: 1, offset: 22859},
			expr: &actionExpr{
				pos: position{line: 665, col: 23, offset: 22881},
				run: (*parser).callonMathAtn2Expression1,
				expr: &seqExpr{
					pos: position{line: 665, col: 23, offset: 22881},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 665, col: 23, offset: 22881},
							val:        "atn2",
							ignoreCase: true,
							want:       "\"ATN2\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 665, col: 31, offset: 22889},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 665, col: 34, offset: 22892},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 665, col: 38, offset: 22896},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 665, col: 41, offset: 22899},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 665, col: 46, offset: 22904},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 665, col: 57, offset: 22915},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 665, col: 60, offset: 22918},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 665, col: 64, offset: 22922},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 665, col: 67, offset: 22925},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 665, col: 72, offset: 22930},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 665, col: 83, offset: 22941},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 665, col: 86, offset: 22944},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntAddExpression",
			pos:  position{line: 666, col: 1, offset: 23035},
			expr: &actionExpr{
				pos: position{line: 666, col: 25, offset: 23059},
				run: (*parser).callonMathIntAddExpression1,
				expr: &seqExpr{
					pos: position{line: 666, col: 25, offset: 23059},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 666, col: 25, offset: 23059},
							val:        "intadd",
							ignoreCase: true,
							want:       "\"IntAdd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 666, col: 35, offset: 23069},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 666, col: 38, offset: 23072},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 666, col: 42, offset: 23076},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 666, col: 45, offset: 23079},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 666, col: 50, offset: 23084},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 666, col: 61, offset: 23095},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 666, col: 64, offset: 23098},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 666, col: 68, offset: 23102},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 666, col: 71, offset: 23105},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 666, col: 76, offset: 23110},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 666, col: 87, offset: 23121},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 666, col: 90, offset: 23124},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitAndExpression",
			pos:  position{line: 667, col: 1, offset: 23217},
			expr: &actionExpr{
				pos: position{line: 667, col: 28, offset: 23244},
				run: (*parser).callonMathIntBitAndExpression1,
				expr: &seqExpr{
					pos: position{line: 667, col: 28, offset: 23244},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 667, col: 28, offset: 23244},
							val:        "intbitand",
							ignoreCase: true,
							want:       "\"IntBitAnd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 667, col: 41, offset: 23257},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 667, col: 44, offset: 23260},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 667, col: 48, offset: 23264},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 667, col: 51, offset: 23267},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 667, col: 56, offset: 23272},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 667, col: 67, offset: 23283},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 667, col: 70, offset: 23286},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 667, col: 74, offset: 23290},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 667, col: 77, offset: 23293},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 667, col: 82, offset: 23298},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 667, col: 93, offset: 23309},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 667, col: 96, offset: 23312},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitLeftShiftExpression",
			pos:  position{line: 668, col: 1, offset: 23408},
			expr: &actionExpr{
				pos: position{line: 668, col: 34, offset: 23441},
				run: (*parser).callonMathIntBitLeftShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 668, col: 34, offset: 23441},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 668, col: 34, offset: 23441},
							val:        "intbitleftshift",
							ignoreCase: true,
							want:       "\"IntBitLeftShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 53, offset: 23460},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 668, col: 56, offset: 23463},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 60, offset: 23467},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 668, col: 63, offset: 23470},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 668, col: 68, offset: 23475},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 79, offset: 23486},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 668, col: 82, offset: 23489},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 86, offset: 23493},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 668, col: 89, offset: 23496},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 668, col: 94, offset: 23501},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 105, offset: 23512},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 668, col: 108, offset: 23515},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitOrExpression",
			pos:  position{line: 669, col: 1, offset: 23617},
			expr: &actionExpr{
				pos: position{line: 669, col: 27, offset: 23643},
				run: (*parser).callonMathIntBitOrExpression1,
				expr: &seqExpr{
					pos: position{line: 669, col: 27, offset: 23643},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 669, col: 27, offset: 23643},
							val:        "intbitor",
							ignoreCase: true,
							want:       "\"IntBitOr\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 669, col: 39, offset: 23655},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 669, col: 42, offset: 23658},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 669, col: 46, offset: 23662},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 669, col: 49, offset: 23665},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 669, col: 54, offset: 23670},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 669, col: 65, offset: 23681},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 669, col: 68, offset: 23684},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 669, col: 72, offset: 23688},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 669, col: 75, offset: 23691},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 669, col: 80, offset: 23696},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 669, col: 91, offset: 23707},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 669, col: 94, offset: 23710},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitRightShiftExpression",
			pos:  position{line: 670, col: 1, offset: 23805},
			expr: &actionExpr{
				pos: position{line: 670, col: 35, offset: 23839},
				run: (*parser).callonMathIntBitRightShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 670, col: 35, offset: 23839},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 670, col: 35, offset: 23839},
							val:        "intbitrightshift",
							ignoreCase: true,
							want:       "\"IntBitRightShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 670, col: 55, offset: 23859},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 670, col: 58, offset: 23862},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 670, col: 62, offset: 23866},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 670, col: 65, offset: 23869},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 670, col: 70, offset: 23874},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 670, col: 81, offset: 23885},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 670, col: 84, offset: 23888},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 670, col: 88, offset: 23892},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 670, col: 91, offset: 23895},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 670, col: 96, offset: 23900},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 670, col: 107, offset: 23911},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 670, col: 110, offset: 23914},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitXorExpression",
			pos:  position{line: 671, col: 1, offset: 24017},
			expr: &actionExpr{
				pos: position{line: 671, col: 28, offset: 24044},
				run: (*parser).callonMathIntBitXorExpression1,
				expr: &seqExpr{
					pos: position{line: 671, col: 28, offset: 24044},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 671, col: 28, offset: 24044},
							val:        "intbitxor",
							ignoreCase: true,
							want:       "\"IntBitXor\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 671, col: 41, offset: 24057},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 671, col: 44, offset: 24060},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 671, col: 48, offset: 24064},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 671, col: 51, offset: 24067},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 671, col: 56, offset: 24072},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 671, col: 67, offset: 24083},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 671, col: 70, offset: 24086},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 671, col: 74, offset: 24090},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 671, col: 77, offset: 24093},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 671, col: 82, offset: 24098},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 671, col: 93, offset: 24109},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 671, col: 96, offset: 24112},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntDivExpression",
			pos:  position{line: 672, col: 1, offset: 24208},
			expr: &actionExpr{
				pos: position{line: 672, col: 25, offset: 24232},
				run: (*parser).callonMathIntDivExpression1,
				expr: &seqExpr{
					pos: position{line: 672, col: 25, offset: 24232},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 672, col: 25, offset: 24232},
							val:        "intdiv",
							ignoreCase: true,
							want:       "\"IntDiv\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 35, offset: 24242},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 672, col: 38, offset: 24245},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 42, offset: 24249},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 672, col: 45, offset: 24252},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 672, col: 50, offset: 24257},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 61, offset: 24268},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 672, col: 64, offset: 24271},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 68, offset: 24275},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 672, col: 71, offset: 24278},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 672, col: 76, offset: 24283},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 87, offset: 24294},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 672, col: 90, offset: 24297},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntModExpression",
			pos:  position{line: 673, col: 1, offset: 24390},
			expr: &actionExpr{
				pos: position{line: 673, col: 25, offset: 24414},
				run: (*parser).callonMathIntModExpression1,
				expr: &seqExpr{
					pos: position{line: 673, col: 25, offset: 24414},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 673, col: 25, offset: 24414},
							val:        "intmod",
							ignoreCase: true,
							want:       "\"IntMod\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 673, col: 35, offset: 24424},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 673, col: 38, offset: 24427},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 673, col: 42, offset: 24431},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 673, col: 45, offset: 24434},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 673, col: 50, offset: 24439},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 673, col: 61, offset: 24450},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 673, col: 64, offset: 24453},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 673, col: 68, offset: 24457},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 673, col: 71, offset: 24460},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 673, col: 76, offset: 24465},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 673, col: 87, offset: 24476},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 673, col: 90, offset: 24479},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntMulExpression",
			pos:  position{line: 674, col: 1, offset: 24572},
			expr: &actionExpr{
				pos: position{line: 674, col: 25, offset: 24596},
				run: (*parser).callonMathIntMulExpression1,
				expr: &seqExpr{
					pos: position{line: 674, col: 25, offset: 24596},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 674, col: 25, offset: 24596},
							val:        "intmul",
							ignoreCase: true,
							want:       "\"IntMul\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 674, col: 35, offset: 24606},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 674, col: 38, offset: 24609},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 674, col: 42, offset: 24613},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 674, col: 45, offset: 24616},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 674, col: 50, offset: 24621},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 674, col: 61, offset: 24632},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 674, col: 64, offset: 24635},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 674, col: 68, offset: 24639},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 674, col: 71, offset: 24642},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 674, col: 76, offset: 24647},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 674, col: 87, offset: 24658},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 674, col: 90, offset: 24661},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntSubExpression",
			pos:  position{line: 675, col: 1, offset: 24754},
			expr: &actionExpr{
				pos: position{line: 675, col: 25, offset: 24778},
				run: (*parser).callonMathIntSubExpression1,
				expr: &seqExpr{
					pos: position{line: 675, col: 25, offset: 24778},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 675, col: 25, offset: 24778},
							val:        "intsub",
							ignoreCase: true,
							want:       "\"IntSub\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 675, col: 35, offset: 24788},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 675, col: 38, offset: 24791},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 675, col: 42, offset: 24795},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 675, col: 45, offset: 24798},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 675, col: 50, offset: 24803},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 675, col: 61, offset: 24814},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 675, col: 64, offset: 24817},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 675, col: 68, offset: 24821},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 675, col: 71, offset: 24824},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 675, col: 76, offset: 24829},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 675, col: 87, offset: 24840},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 675, col: 90, offset: 24843},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPowerExpression",
			pos:  position{line: 676, col: 1, offset: 24936},
			expr: &actionExpr{
				pos: position{line: 676, col: 24, offset: 24959},
				run: (*parser).callonMathPowerExpression1,
				expr: &seqExpr{
					pos: position{line: 676, col: 24, offset: 24959},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 676, col: 24, offset: 24959},
							val:        "power",
							ignoreCase: true,
							want:       "\"POWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 33, offset: 24968},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 676, col: 36, offset: 24971},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 40, offset: 24975},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 676, col: 43, offset: 24978},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 676, col: 48, offset: 24983},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 59, offset: 24994},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 676, col: 62, offset: 24997},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 66, offset: 25001},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 676, col: 69, offset: 25004},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 676, col: 74, offset: 25009},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 85, offset: 25020},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 676, col: 88, offset: 25023},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLogExpression",
			pos:  position{line: 678, col: 1, offset: 25116},
			expr: &actionExpr{
				pos: position{line: 678, col: 22, offset: 25137},
				run: (*parser).callonMathLogExpression1,
				expr: &seqExpr{
					pos: position{line: 678, col: 22, offset: 25137},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 678, col: 22, offset: 25137},
							val:        "log",
							ignoreCase: true,
							want:       "\"LOG\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 678, col: 29, offset: 25144},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 678, col: 32, offset: 25147},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 678, col: 36, offset: 25151},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 678, col: 39, offset: 25154},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 678, col: 43, offset: 25158},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 678, col: 54, offset: 25169},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 678, col: 61, offset: 25176},
								expr: &actionExpr{
									pos: position{line: 678, col: 62, offset: 25177},
									run: (*parser).callonMathLogExpression11,
									expr: &seqExpr{
										pos: position{line: 678, col: 62, offset: 25177},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 678, col: 62, offset: 25177},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 678, col: 65, offset: 25180},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 678, col: 69, offset: 25184},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 678, col: 72, offset: 25187},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 678, col: 75, offset: 25190},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 678, col: 107, offset: 25222},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 678, col: 110, offset: 25225},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathNumberBinExpression",
			pos:  position{line: 681, col: 1, offset: 25347},
			expr: &actionExpr{
				pos: position{line: 681, col: 28, offset: 25374},
				run: (*parser).callonMathNumberBinExpression1,
				expr: &seqExpr{
					pos: position{line: 681, col: 28, offset: 25374},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 681, col: 28, offset: 25374},
							val:        "numberbin",
							ignoreCase: true,
							want:       "\"NumberBin\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 681, col: 41, offset: 25387},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 681, col: 44, offset: 25390},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 681, col: 48, offset: 25394},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 681, col: 51, offset: 25397},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 681, col: 55, offset: 25401},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 681, col: 66, offset: 25412},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 681, col: 73, offset: 25419},
								expr: &actionExpr{
									pos: position{line: 681, col: 74, offset: 25420},
									run: (*parser).callonMathNumberBinExpression11,
									expr: &seqExpr{
										pos: position{line: 681, col: 74, offset: 25420},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 681, col: 74, offset: 25420},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 681, col: 77, offset: 25423},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 681, col: 81, offset: 25427},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 681, col: 84, offset: 25430},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 681, col: 87, offset: 25433},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 681, col: 119, offset: 25465},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 681, col: 122, offset: 25468},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPiExpression",
			pos:  position{line: 684, col: 1, offset: 25596},
			expr: &actionExpr{
				pos: position{line: 684, col: 21, offset: 25616},
				run: (*parser).callonMathPiExpression1,
				expr: &seqExpr{
					pos: position{line: 684, col: 21, offset: 25616},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 684, col: 21, offset: 25616},
							val:        "pi",
							ignoreCase: true,
							want:       "\"PI\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 27, offset: 25622},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 684, col: 30, offset: 25625},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 34, offset: 25629},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 684, col: 37, offset: 25632},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRandExpression",
			pos:  position{line: 685, col: 1, offset: 25711},
			expr: &actionExpr{
				pos: position{line: 685, col: 23, offset: 25733},
				run: (*parser).callonMathRandExpression1,
				expr: &seqExpr{
					pos: position{line: 685, col: 23, offset: 25733},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 685, col: 23, offset: 25733},
							val:        "rand",
							ignoreCase: true,
							want:       "\"RAND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 685, col: 31, offset: 25741},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 685, col: 34, offset: 25744},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 685, col: 38, offset: 25748},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 685, col: 41, offset: 25751},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "InFunction",
			pos:  position{line: 687, col: 1, offset: 25833},
			expr: &actionExpr{
				pos: position{line: 687, col: 15, offset: 25847},
				run: (*parser).callonInFunction1,
				expr: &seqExpr{
					pos: position{line: 687, col: 15, offset: 25847},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 687, col: 15, offset: 25847},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 687, col: 19, offset: 25851},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 34, offset: 25866},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 687, col: 37, offset: 25869},
							val:        "in",
							ignoreCase: true,
							want:       "\"IN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 43, offset: 25875},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 687, col: 46, offset: 25878},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 50, offset: 25882},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 687, col: 53, offset: 25885},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 687, col: 57, offset: 25889},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 687, col: 68, offset: 25900},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 687, col: 75, offset: 25907},
								expr: &actionExpr{
									pos: position{line: 687, col: 76, offset: 25908},
									run: (*parser).callonInFunction14,
									expr: &seqExpr{
										pos: position{line: 687, col: 76, offset: 25908},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 687, col: 76, offset: 25908},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 687, col: 79, offset: 25911},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 687, col: 83, offset: 25915},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 687, col: 86, offset: 25918},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 687, col: 89, offset: 25921},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 121, offset: 25953},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 687, col: 124, offset: 25956},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "AvgAggregateExpression",
			pos:  position{line: 691, col: 1, offset: 26079},
			expr: &actionExpr{
				pos: position{line: 691, col: 29, offset: 26107},
				run: (*parser).callonAvgAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 691, col: 29, offset: 26107},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 691, col: 29, offset: 26107},
							val:        "avg",
							ignoreCase: true,
							want:       "\"AVG\"i",
						},
						&litMatcher{
							pos:        position{line: 691, col: 36, offset: 26114},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 40, offset: 26118},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 691, col: 43, offset: 26121},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 691, col: 46, offset: 26124},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 58, offset: 26136},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 691, col: 61, offset: 26139},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "CountAggregateExpression",
			pos:  position{line: 695, col: 1, offset: 26231},
			expr: &actionExpr{
				pos: position{line: 695, col: 29, offset: 26259},
				run: (*parser).callonCountAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 695, col: 29, offset: 26259},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 695, col: 29, offset: 26259},
							val:        "count",
							ignoreCase: true,
							want:       "\"COUNT\"i",
						},
						&litMatcher{
							pos:        position{line: 695, col: 38, offset: 26268},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 695, col: 42, offset: 26272},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 695, col: 45, offset: 26275},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 695, col: 48, offset: 26278},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 695, col: 59, offset: 26289},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 695, col: 62, offset: 26292},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MaxAggregateExpression",
			pos:  position{line: 699, col: 1, offset: 26386},
			expr: &actionExpr{
				pos: position{line: 699, col: 29, offset: 26414},
				run: (*parser).callonMaxAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 699, col: 29, offset: 26414},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 699, col: 29, offset: 26414},
							val:        "max",
							ignoreCase: true,
							want:       "\"MAX\"i",
						},
						&litMatcher{
							pos:        position{line: 699, col: 36, offset: 26421},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 40, offset: 26425},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 699, col: 43, offset: 26428},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 699, col: 46, offset: 26431},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 57, offset: 26442},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 699, col: 60, offset: 26445},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MinAggregateExpression",
			pos:  position{line: 703, col: 1, offset: 26537},
			expr: &actionExpr{
				pos: position{line: 703, col: 29, offset: 26565},
				run: (*parser).callonMinAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 703, col: 29, offset: 26565},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 703, col: 29, offset: 26565},
							val:        "min",
							ignoreCase: true,
							want:       "\"MIN\"i",
						},
						&litMatcher{
							pos:        position{line: 703, col: 36, offset: 26572},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 40, offset: 26576},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 703, col: 43, offset: 26579},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 703, col: 46, offset: 26582},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 57, offset: 26593},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 703, col: 60, offset: 26596},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SumAggregateExpression",
			pos:  position{line: 707, col: 1, offset: 26688},
			expr: &actionExpr{
				pos: position{line: 707, col: 29, offset: 26716},
				run: (*parser).callonSumAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 707, col: 29, offset: 26716},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 707, col: 29, offset: 26716},
							val:        "sum",
							ignoreCase: true,
							want:       "\"SUM\"i",
						},
						&litMatcher{
							pos:        position{line: 707, col: 36, offset: 26723},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 40, offset: 26727},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 707, col: 43, offset: 26730},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 707, col: 46, offset: 26733},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 57, offset: 26744},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 707, col: 60, offset: 26747},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "Integer",
			pos:  position{line: 711, col: 1, offset: 26839},
			expr: &actionExpr{
				pos: position{line: 711, col: 12, offset: 26850},
				run: (*parser).callonInteger1,
				expr: &oneOrMoreExpr{
					pos: position{line: 711, col: 12, offset: 26850},
					expr: &charClassMatcher{
						pos:        position{line: 711, col: 12, offset: 26850},
						val:        "[0-9]",
						ranges:     []rune{'0', '9'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "StringCharacter",
			pos:  position{line: 715, col: 1, offset: 26902},
			expr: &choiceExpr{
				pos: position{line: 715, col: 20, offset: 26921},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 715, col: 20, offset: 26921},
						run: (*parser).callonStringCharacter2,
						expr: &seqExpr{
							pos: position{line: 715, col: 20, offset: 26921},
							exprs: []any{
								&notExpr{
									pos: position{line: 715, col: 20, offset: 26921},
									expr: &choiceExpr{
										pos: position{line: 715, col: 22, offset: 26923},
										alternatives: []any{
											&litMatcher{
												pos:        position{line: 715, col: 22, offset: 26923},
												val:        "\"",
												ignoreCase: false,
												want:       "\"\\\"\"",
											},
											&litMatcher{
												pos:        position{line: 715, col: 28, offset: 26929},
												val:        "\\",
												ignoreCase: false,
												want:       "\"\\\\\"",
											},
										},
									},
								},
								&anyMatcher{
									line: 715, col: 34, offset: 26935,
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 716, col: 5, offset: 26972},
						run: (*parser).callonStringCharacter9,
						expr: &seqExpr{
							pos: position{line: 716, col: 5, offset: 26972},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 716, col: 5, offset: 26972},
									val:        "\\",
									ignoreCase: false,
									want:       "\"\\\\\"",
								},
								&labeledExpr{
									pos:   position{line: 716, col: 10, offset: 26977},
									label: "seq",
									expr: &ruleRefExpr{
										pos:  position{line: 716, col: 14, offset: 26981},
										name: "EscapeSequenceCharacter",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "EscapeSequenceCharacter",
			pos:  position{line: 718, col: 1, offset: 27026},
			expr: &labeledExpr{
				pos:   position{line: 718, col: 28, offset: 27053},
				label: "char",
				expr: &ruleRefExpr{
					pos:  position{line: 718, col: 33, offset: 27058},
					name: "EscapeCharacter",
				},
			},
		},
		{
			name: "EscapeCharacter",
			pos:  position{line: 720, col: 1, offset: 27075},
			expr: &choiceExpr{
				pos: position{line: 720, col: 20, offset: 27094},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 720, col: 20, offset: 27094},
						val:        "'",
						ignoreCase: false,
						want:       "\"'\"",
					},
					&litMatcher{
						pos:        position{line: 721, col: 5, offset: 27102},
						val:        "\"",
						ignoreCase: false,
						want:       "\"\\\"\"",
					},
					&litMatcher{
						pos:        position{line: 722, col: 5, offset: 27110},
						val:        "\\",
						ignoreCase: false,
						want:       "\"\\\\\"",
					},
					&actionExpr{
						pos: position{line: 723, col: 5, offset: 27119},
						run: (*parser).callonEscapeCharacter5,
						expr: &litMatcher{
							pos:        position{line: 723, col: 5, offset: 27119},
							val:        "b",
							ignoreCase: false,
							want:       "\"b\"",
						},
					},
					&actionExpr{
						pos: position{line: 724, col: 5, offset: 27148},
						run: (*parser).callonEscapeCharacter7,
						expr: &litMatcher{
							pos:        position{line: 724, col: 5, offset: 27148},
							val:        "f",
							ignoreCase: false,
							want:       "\"f\"",
						},
					},
					&actionExpr{
						pos: position{line: 725, col: 5, offset: 27177},
						run: (*parser).callonEscapeCharacter9,
						expr: &litMatcher{
							pos:        position{line: 725, col: 5, offset: 27177},
							val:        "n",
							ignoreCase: false,
							want:       "\"n\"",
						},
					},
					&actionExpr{
						pos: position{line: 726, col: 5, offset: 27206},
						run: (*parser).callonEscapeCharacter11,
						expr: &litMatcher{
							pos:        position{line: 726, col: 5, offset: 27206},
							val:        "r",
							ignoreCase: false,
							want:       "\"r\"",
						},
					},
					&actionExpr{
						pos: position{line: 727, col: 5, offset: 27235},
						run: (*parser).callonEscapeCharacter13,
						expr: &litMatcher{
							pos:        position{line: 727, col: 5, offset: 27235},
							val:        "t",
							ignoreCase: false,
							want:       "\"t\"",
						},
					},
				},
			},
		},
		{
			name: "non_escape_character",
			pos:  position{line: 729, col: 1, offset: 27261},
			expr: &actionExpr{
				pos: position{line: 729, col: 25, offset: 27285},
				run: (*parser).callonnon_escape_character1,
				expr: &seqExpr{
					pos: position{line: 729, col: 25, offset: 27285},
					exprs: []any{
						&notExpr{
							pos: position{line: 729, col: 25, offset: 27285},
							expr: &ruleRefExpr{
								pos:  position{line: 729, col: 27, offset: 27287},
								name: "escape_character",
							},
						},
						&labeledExpr{
							pos:   position{line: 729, col: 45, offset: 27305},
							label: "char",
							expr: &anyMatcher{
								line: 729, col: 50, offset: 27310,
							},
						},
					},
				},
			},
		},
		{
			name: "ws",
			pos:  position{line: 732, col: 1, offset: 27349},
			expr: &zeroOrMoreExpr{
				pos: position{line: 732, col: 7, offset: 27355},
				expr: &charClassMatcher{
					pos:        position{line: 732, col: 7, offset: 27355},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "wss",
			pos:  position{line: 734, col: 1, offset: 27367},
			expr: &oneOrMoreExpr{
				pos: position{line: 734, col: 8, offset: 27374},
				expr: &charClassMatcher{
					pos:        position{line: 734, col: 8, offset: 27374},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "EOF",
			pos:  position{line: 736, col: 1, offset: 27386},
			expr: &notExpr{
				pos: position{line: 736, col: 8, offset: 27393},
				expr: &anyMatcher{
					line: 736, col: 9, offset: 27394,
				},
			},
		},
	},
}

func (c *current) onInput1(selectStmt any) (any, error) {
	return selectStmt, nil
}

func (p *parser) callonInput1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["selectStmt"])
}

func (c *current) onSelectStmt22(join any) (any, error) {
	return join, nil
}

func (p *parser) callonSelectStmt22() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt22(stack["join"])
}

func (c *current) onSelectStmt30(condition any) (any, error) {
	return condition, nil
}

func (p *parser) callonSelectStmt30() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt30(stack["condition"])
}

func (c *current) onSelectStmt39(columns any) (any, error) {
	return columns, nil
}

func (p *parser) callonSelectStmt39() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt39(stack["columns"])
}

func (c *current) onSelectStmt48(order any) (any, error) {
	return order, nil
}

func (p *parser) callonSelectStmt48() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt48(stack["order"])
}

func (c *current) onSelectStmt55(offset any) (any, error) {
	return offset, nil
}

func (p *parser) callonSelectStmt55() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt55(stack["offset"])
}

func (c *current) onSelectStmt1(distinctClause, topClause, columns, fromClause, joinClauses, whereClause, groupByClause, orderByClause, offsetClause any) (any, error) {
	return makeSelectStmt(columns, fromClause, joinClauses, whereClause,
		distinctClause, topClause, groupByClause, orderByClause, offsetClause)
}

func (p *parser) callonSelectStmt1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt1(stack["distinctClause"], stack["topClause"], stack["columns"], stack["fromClause"], stack["joinClauses"], stack["whereClause"], stack["groupByClause"], stack["orderByClause"], stack["offsetClause"])
}

func (c *current) onTopClause1(count any) (any, error) {
	return count, nil
}

func (p *parser) callonTopClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTopClause1(stack["count"])
}

func (c *current) onFromClause10(column any) (any, error) {
	return column, nil
}

func (p *parser) callonFromClause10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause10(stack["column"])
}

func (c *current) onFromClause2(table, selectItem any) (any, error) {
	tableTyped := table.(parsers.Table)

	if selectItem != nil {
		tableTyped.SelectItem = selectItem.(parsers.SelectItem)
	}

	return tableTyped, nil
}

func (p *parser) callonFromClause2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause2(stack["table"], stack["selectItem"])
}

func (c *current) onFromClause17(subQuery any) (any, error) {
	subQueryTyped := subQuery.(parsers.SelectItem)
	table := parsers.Table{
		Value:      subQueryTyped.Alias,
		SelectItem: subQueryTyped,
	}
	return table, nil
}

func (p *parser) callonFromClause17() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause17(stack["subQuery"])
}

func (c *current) onSubQuery5(exists any) (any, error) {
	return exists, nil
}

func (p *parser) callonSubQuery5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuery5(stack["exists"])
}

func (c *current) onSubQuery1(exists, selectStmt any) (any, error) {
	if selectStatement, isGoodValue := selectStmt.(parsers.SelectStmt); isGoodValue {
		selectStatement.Exists = exists != nil
		return selectStatement, nil
	}

	return selectStmt, nil
}

func (p *parser) callonSubQuery1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuery1(stack["exists"], stack["selectStmt"])
}

func (c *current) onSubQuerySelectItem7(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonSubQuerySelectItem7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuerySelectItem7(stack["alias"])
}

func (c *current) onSubQuerySelectItem1(subQuery, asClause any) (any, error) {
	selectItem := parsers.SelectItem{
		Type:  parsers.SelectItemTypeSubQuery,
		Value: subQuery,
	}

	if tableName, isString := asClause.(string); isString {
		selectItem.Alias = tableName
	}

	return selectItem, nil
}

func (p *parser) callonSubQuerySelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuerySelectItem1(stack["subQuery"], stack["asClause"])
}

func (c *current) onJoinClause2(table, column any) (any, error) {
	return makeJoin(table, column)
}

func (p *parser) callonJoinClause2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onJoinClause2(stack["table"], stack["column"])
}

func (c *current) onJoinClause13(subQuery any) (any, error) {
	return makeJoin(nil, subQuery)
}

func (p *parser) callonJoinClause13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onJoinClause13(stack["subQuery"])
}

func (c *current) onOffsetClause1(offset, limit any) (any, error) {
	return []interface{}{offset.(parsers.Constant).Value, limit.(parsers.Constant).Value}, nil
}

func (p *parser) callonOffsetClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOffsetClause1(stack["offset"], stack["limit"])
}

func (c *current) onSelectAsterisk1() (any, error) {
	selectItem, _ := makeSelectItem("c", make([]interface{}, 0), parsers.SelectItemTypeField)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectAsterisk1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectAsterisk1()
}

func (c *current) onColumnList7(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonColumnList7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList7(stack["coll"])
}

func (c *current) onColumnList1(column, other_columns any) (any, error) {
	return makeColumnList(column, other_columns)
}

func (p *parser) callonColumnList1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList1(stack["column"], stack["other_columns"])
}

func (c *current) onSelectValueSpec1(column any) (any, error) {
	selectItem := column.(parsers.SelectItem)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectValueSpec1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectValueSpec1(stack["column"])
}

func (c *current) onTableName1(key any) (any, error) {
	return parsers.Table{Value: key.(string)}, nil
}

func (p *parser) callonTableName1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTableName1(stack["key"])
}

func (c *current) onSelectArray1(columns any) (any, error) {
	return makeSelectArray(columns)
}

func (p *parser) callonSelectArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectArray1(stack["columns"])
}

func (c *current) onSelectObject10(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonSelectObject10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject10(stack["coll"])
}

func (c *current) onSelectObject1(field, other_fields any) (any, error) {
	return makeSelectObject(field, other_fields)
}

func (p *parser) callonSelectObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject1(stack["field"], stack["other_fields"])
}

func (c *current) onSelectObjectField6(key any) (any, error) {
	return key, nil
}

func (p *parser) callonSelectObjectField6() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField6(stack["key"])
}

func (c *current) onSelectObjectField1(name, selectItem any) (any, error) {
	item := selectItem.(parsers.SelectItem)
	item.Alias = name.(string)
	return item, nil
}

func (p *parser) callonSelectObjectField1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField1(stack["name"], stack["selectItem"])
}

func (c *current) onSelectProperty1(name, path any) (any, error) {
	return makeSelectItem(name, path, parsers.SelectItemTypeField)
}

func (p *parser) callonSelectProperty1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectProperty1(stack["name"], stack["path"])
}

func (c *current) onSelectItem1(selectItem, asClause any) (any, error) {
	var itemResult parsers.SelectItem
	switch typedValue := selectItem.(type) {
	case parsers.SelectItem:
		itemResult = typedValue
	case parsers.Constant:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeConstant,
			Value: typedValue,
		}
	case parsers.FunctionCall:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeFunctionCall,
			Value: typedValue,
		}
	}

	if aliasValue, ok := asClause.(string); ok {
		itemResult.Alias = aliasValue
	}

	return itemResult, nil
}

func (p *parser) callonSelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectItem1(stack["selectItem"], stack["asClause"])
}

func (c *current) onAsClause1(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonAsClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAsClause1(stack["alias"])
}

func (c *current) onDotFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonDotFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDotFieldAccess1(stack["id"])
}

func (c *current) onArrayFieldAccess2(id any) (any, error) {
	return id, nil
}

func (p *parser) callonArrayFieldAccess2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess2(stack["id"])
}

func (c *current) onArrayFieldAccess8(id any) (any, error) {
	return strconv.Itoa(id.(int)), nil
}

func (p *parser) callonArrayFieldAccess8() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess8(stack["id"])
}

func (c *current) onIdentifier1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonIdentifier1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIdentifier1()
}

func (c *current) onCondition1(expression any) (any, error) {
	return expression, nil
}

func (p *parser) callonCondition1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCondition1(stack["expression"])
}

func (c *current) onOrExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression7(stack["ex"])
}

func (c *current) onOrExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeOr)
}

func (p *parser) callonOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onAndExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonAndExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression7(stack["ex"])
}

func (c *current) onAndExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeAnd)
}

func (p *parser) callonAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onComparisonExpression2(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression2(stack["ex"])
}

func (c *current) onComparisonExpression10(left, op, right any) (any, error) {
	return parsers.ComparisonExpression{Left: left, Right: right, Operation: op.(string)}, nil
}

func (p *parser) callonComparisonExpression10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression10(stack["left"], stack["op"], stack["right"])
}

func (c *current) onComparisonExpression20(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression20() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression20(stack["ex"])
}

func (c *current) onComparisonExpression23(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression23() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression23(stack["ex"])
}

func (c *current) onOrderByClause9(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrderByClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause9(stack["ex"])
}

func (c *current) onOrderByClause1(ex1, others any) (any, error) {
	return makeOrderByClause(ex1, others)
}

func (p *parser) callonOrderByClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause1(stack["ex1"], stack["others"])
}

func (c *current) onOrderExpression1(field, order any) (any, error) {
	return makeOrderExpression(field, order)
}

func (p *parser) callonOrderExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderExpression1(stack["field"], stack["order"])
}

func (c *current) onOrderDirection1() (any, error) {
	if strings.EqualFold(string(c.text), "DESC") {
		return parsers.OrderDirectionDesc, nil
	}

	return parsers.OrderDirectionAsc, nil
}

func (p *parser) callonOrderDirection1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderDirection1()
}

func (c *current) onComparisonOperator1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonComparisonOperator1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonOperator1()
}

func (c *current) onParameterConstant1() (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeParameterConstant, Value: string(c.text)}, nil
}

func (p *parser) callonParameterConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onParameterConstant1()
}

func (c *current) onNullConstant1() (any, error) {
	return parsers.Constant{Value: nil}, nil
}

func (p *parser) callonNullConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onNullConstant1()
}

func (c *current) onIntegerLiteral1(number any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeInteger, Value: number.(int)}, nil
}

func (p *parser) callonIntegerLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIntegerLiteral1(stack["number"])
}

func (c *current) onStringLiteral1(chars any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeString, Value: joinStrings(chars.([]interface{}))}, nil
}

func (p *parser) callonStringLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringLiteral1(stack["chars"])
}

func (c *current) onFloatLiteral1() (any, error) {
	floatValue, _ := strconv.ParseFloat(string(c.text), 64)
	return parsers.Constant{Type: parsers.ConstantTypeFloat, Value: floatValue}, nil
}

func (p *parser) callonFloatLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFloatLiteral1()
}

func (c *current) onBooleanLiteral1() (any, error) {
	boolValue, _ := strconv.ParseBool(string(c.text))
	return parsers.Constant{Type: parsers.ConstantTypeBoolean, Value: boolValue}, nil
}

func (p *parser) callonBooleanLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onBooleanLiteral1()
}

func (c *current) onUpperExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallUpper, []interface{}{ex})
}

func (p *parser) callonUpperExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onUpperExpression1(stack["ex"])
}

func (c *current) onLowerExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLower, []interface{}{ex})
}

func (p *parser) callonLowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLowerExpression1(stack["ex"])
}

func (c *current) onStringEqualsExpression17(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonStringEqualsExpression17() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression17(stack["boolean"])
}

func (c *current) onStringEqualsExpression1(ex1, ex2, ignoreCase any) (any, error) {
	return createFunctionCall(parsers.FunctionCallStringEquals, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonStringEqualsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression1(stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onToStringExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallToString, []interface{}{ex})
}

func (p *parser) callonToStringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onToStringExpression1(stack["ex"])
}

func (c *current) onConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression11(stack["ex"])
}

func (c *current) onConcatExpression1(ex1, others any) (any, error) {
	arguments := append([]interface{}{ex1}, others.([]interface{})...)
	return createFunctionCall(parsers.FunctionCallConcat, arguments)
}

func (p *parser) callonConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression1(stack["ex1"], stack["others"])
}

func (c *current) onLeftExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLeft, []interface{}{ex, length})
}

func (p *parser) callonLeftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLeftExpression1(stack["ex"], stack["length"])
}

func (c *current) onLengthExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLength, []interface{}{ex})
}

func (p *parser) callonLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLengthExpression1(stack["ex"])
}

func (c *current) onLTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLTrim, []interface{}{ex})
}

func (p *parser) callonLTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLTrimExpression1(stack["ex"])
}

func (c *current) onReplaceExpression1(ex1, ex2, ex3 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplace, []interface{}{ex1, ex2, ex3})
}

func (p *parser) callonReplaceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplaceExpression1(stack["ex1"], stack["ex2"], stack["ex3"])
}

func (c *current) onReplicateExpression1(ex1, ex2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplicate, []interface{}{ex1, ex2})
}

func (p *parser) callonReplicateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplicateExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onReverseExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReverse, []interface{}{ex})
}

func (p *parser) callonReverseExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReverseExpression1(stack["ex"])
}

func (c *current) onRightExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRight, []interface{}{ex, length})
}

func (p *parser) callonRightExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRightExpression1(stack["ex"], stack["length"])
}

func (c *current) onRTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRTrim, []interface{}{ex})
}

func (p *parser) callonRTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRTrimExpression1(stack["ex"])
}

func (c *current) onSubstringExpression1(ex, startPos, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSubstring, []interface{}{ex, startPos, length})
}

func (p *parser) callonSubstringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubstringExpression1(stack["ex"], stack["startPos"], stack["length"])
}

func (c *current) onTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallTrim, []interface{}{ex})
}

func (p *parser) callonTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTrimExpression1(stack["ex"])
}

func (c *current) onThreeArgumentStringFunctionExpression18(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonThreeArgumentStringFunctionExpression18() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression18(stack["boolean"])
}

func (c *current) onThreeArgumentStringFunctionExpression1(function, ex1, ex2, ignoreCase any) (any, error) {
	var functionType parsers.FunctionCallType

	lowerFunction := strings.ToUpper(function.(string))
	switch lowerFunction {
	case "CONTAINS":
		functionType = parsers.FunctionCallContains
	case "ENDSWITH":
		functionType = parsers.FunctionCallEndsWith
	case "STARTSWITH":
		functionType = parsers.FunctionCallStartsWith
	case "INDEX_OF":
		functionType = parsers.FunctionCallIndexOf
	}

	return createFunctionCall(functionType, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonThreeArgumentStringFunctionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression1(stack["function"], stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onThreeArgumentStringFunction1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonThreeArgumentStringFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunction1()
}

func (c *current) onIsDefined1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsDefined, []interface{}{ex})
}

func (p *parser) callonIsDefined1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsDefined1(stack["ex"])
}

func (c *current) onIsArray1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsArray, []interface{}{ex})
}

func (p *parser) callonIsArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsArray1(stack["ex"])
}

func (c *current) onIsBool1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsBool, []interface{}{ex})
}

func (p *parser) callonIsBool1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsBool1(stack["ex"])
}

func (c *current) onIsFiniteNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsFiniteNumber, []interface{}{ex})
}

func (p *parser) callonIsFiniteNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsFiniteNumber1(stack["ex"])
}

func (c *current) onIsInteger1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsInteger, []interface{}{ex})
}

func (p *parser) callonIsInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsInteger1(stack["ex"])
}

func (c *current) onIsNull1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNull, []interface{}{ex})
}

func (p *parser) callonIsNull1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNull1(stack["ex"])
}

func (c *current) onIsNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNumber, []interface{}{ex})
}

func (p *parser) callonIsNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNumber1(stack["ex"])
}

func (c *current) onIsObject1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsObject, []interface{}{ex})
}

func (p *parser) callonIsObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsObject1(stack["ex"])
}

func (c *current) onIsPrimitive1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsPrimitive, []interface{}{ex})
}

func (p *parser) callonIsPrimitive1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsPrimitive1(stack["ex"])
}

func (c *current) onIsString1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsString, []interface{}{ex})
}

func (p *parser) callonIsString1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsString1(stack["ex"])
}

func (c *current) onArrayConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression11(stack["ex"])
}

func (c *current) onArrayConcatExpression1(arrays, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayConcat, append([]interface{}{arrays}, others.([]interface{})...))
}

func (p *parser) callonArrayConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression1(stack["arrays"], stack["others"])
}

func (c *current) onArrayLengthExpression1(array any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayLength, []interface{}{array})
}

func (p *parser) callonArrayLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayLengthExpression1(stack["array"])
}

func (c *current) onArraySliceExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArraySliceExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression16(stack["ex"])
}

func (c *current) onArraySliceExpression1(array, start, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArraySlice, []interface{}{array, start, length})
}

func (p *parser) callonArraySliceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression1(stack["array"], stack["start"], stack["length"])
}

func (c *current) onSetIntersectExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetIntersect, []interface{}{set1, set2})
}

func (p *parser) callonSetIntersectExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetIntersectExpression1(stack["set1"], stack["set2"])
}

func (c *current) onSetUnionExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetUnion, []interface{}{set1, set2})
}

func (p *parser) callonSetUnionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetUnionExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathAbsExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAbs, []interface{}{ex})
}

func (p *parser) callonMathAbsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAbsExpression1(stack["ex"])
}

func (c *current) onMathAcosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAcos, []interface{}{ex})
}

func (p *parser) callonMathAcosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAcosExpression1(stack["ex"])
}

func (c *current) onMathAsinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAsin, []interface{}{ex})
}

func (p *parser) callonMathAsinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAsinExpression1(stack["ex"])
}

func (c *current) onMathAtanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtan, []interface{}{ex})
}

func (p *parser) callonMathAtanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtanExpression1(stack["ex"])
}

func (c *current) onMathCeilingExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCeiling, []interface{}{ex})
}

func (p *parser) callonMathCeilingExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCeilingExpression1(stack["ex"])
}

func (c *current) onMathCosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCos, []interface{}{ex})
}

func (p *parser) callonMathCosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCosExpression1(stack["ex"])
}

func (c *current) onMathCotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCot, []interface{}{ex})
}

func (p *parser) callonMathCotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCotExpression1(stack["ex"])
}

func (c *current) onMathDegreesExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathDegrees, []interface{}{ex})
}

func (p *parser) callonMathDegreesExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathDegreesExpression1(stack["ex"])
}

func (c *current) onMathExpExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathExp, []interface{}{ex})
}

func (p *parser) callonMathExpExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathExpExpression1(stack["ex"])
}

func (c *current) onMathFloorExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathFloor, []interface{}{ex})
}

func (p *parser) callonMathFloorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathFloorExpression1(stack["ex"])
}

func (c *current) onMathIntBitNotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitNot, []interface{}{ex})
}

func (p *parser) callonMathIntBitNotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitNotExpression1(stack["ex"])
}

func (c *current) onMathLog10Expression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog10, []interface{}{ex})
}

func (p *parser) callonMathLog10Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLog10Expression1(stack["ex"])
}

func (c *current) onMathRadiansExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRadians, []interface{}{ex})
}

func (p *parser) callonMathRadiansExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRadiansExpression1(stack["ex"])
}

func (c *current) onMathRoundExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRound, []interface{}{ex})
}

func (p *parser) callonMathRoundExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRoundExpression1(stack["ex"])
}

func (c *current) onMathSignExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSign, []interface{}{ex})
}

func (p *parser) callonMathSignExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSignExpression1(stack["ex"])
}

func (c *current) onMathSinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSin, []interface{}{ex})
}

func (p *parser) callonMathSinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSinExpression1(stack["ex"])
}

func (c *current) onMathSqrtExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSqrt, []interface{}{ex})
}

func (p *parser) callonMathSqrtExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSqrtExpression1(stack["ex"])
}

func (c *current) onMathSquareExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSquare, []interface{}{ex})
}

func (p *parser) callonMathSquareExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSquareExpression1(stack["ex"])
}

func (c *current) onMathTanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTan, []interface{}{ex})
}

func (p *parser) callonMathTanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTanExpression1(stack["ex"])
}

func (c *current) onMathTruncExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTrunc, []interface{}{ex})
}

func (p *parser) callonMathTruncExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTruncExpression1(stack["ex"])
}

func (c *current) onMathAtn2Expression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtn2, []interface{}{set1, set2})
}

func (p *parser) callonMathAtn2Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtn2Expression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntAddExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntAdd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntAddExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntAddExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitAndExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitAnd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitAndExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitLeftShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitLeftShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitLeftShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitLeftShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitOrExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitOr, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitOrExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitRightShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitRightShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitRightShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitRightShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitXorExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitXor, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitXorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitXorExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntDivExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntDiv, []interface{}{set1, set2})
}

func (p *parser) callonMathIntDivExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntDivExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntModExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMod, []interface{}{set1, set2})
}

func (p *parser) callonMathIntModExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntModExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntMulExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMul, []interface{}{set1, set2})
}

func (p *parser) callonMathIntMulExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntMulExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntSubExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntSub, []interface{}{set1, set2})
}

func (p *parser) callonMathIntSubExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntSubExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathPowerExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPower, []interface{}{set1, set2})
}

func (p *parser) callonMathPowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPowerExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathLogExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathLogExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression11(stack["ex"])
}

func (c *current) onMathLogExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathLogExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathNumberBinExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathNumberBinExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression11(stack["ex"])
}

func (c *current) onMathNumberBinExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathNumberBin, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathNumberBinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathPiExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPi, []interface{}{})
}

func (p *parser) callonMathPiExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPiExpression1()
}

func (c *current) onMathRandExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRand, []interface{}{})
}

func (p *parser) callonMathRandExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRandExpression1()
}

func (c *current) onInFunction14(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction14() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction14(stack["ex"])
}

func (c *current) onInFunction1(ex1, ex2, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIn, append([]interface{}{ex1, ex2}, others.([]interface{})...))
}

func (p *parser) callonInFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction1(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onAvgAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateAvg, []interface{}{ex})
}

func (p *parser) callonAvgAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAvgAggregateExpression1(stack["ex"])
}

func (c *current) onCountAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateCount, []interface{}{ex})
}

func (p *parser) callonCountAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCountAggregateExpression1(stack["ex"])
}

func (c *current) onMaxAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMax, []interface{}{ex})
}

func (p *parser) callonMaxAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMaxAggregateExpression1(stack["ex"])
}

func (c *current) onMinAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMin, []interface{}{ex})
}

func (p *parser) callonMinAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMinAggregateExpression1(stack["ex"])
}

func (c *current) onSumAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateSum, []interface{}{ex})
}

func (p *parser) callonSumAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSumAggregateExpression1(stack["ex"])
}

func (c *current) onInteger1() (any, error) {
	return strconv.Atoi(string(c.text))
}

func (p *parser) callonInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInteger1()
}

func (c *current) onStringCharacter2() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonStringCharacter2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter2()
}

func (c *current) onStringCharacter9(seq any) (any, error) {
	return seq, nil
}

func (p *parser) callonStringCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter9(stack["seq"])
}

func (c *current) onEscapeCharacter5() (any, error) {
	return "\b", nil
}

func (p *parser) callonEscapeCharacter5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter5()
}

func (c *current) onEscapeCharacter7() (any, error) {
	return "\f", nil
}

func (p *parser) callonEscapeCharacter7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter7()
}

func (c *current) onEscapeCharacter9() (any, error) {
	return "\n", nil
}

func (p *parser) callonEscapeCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter9()
}

func (c *current) onEscapeCharacter11() (any, error) {
	return "\r", nil
}

func (p *parser) callonEscapeCharacter11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter11()
}

func (c *current) onEscapeCharacter13() (any, error) {
	return "\t", nil
}

func (p *parser) callonEscapeCharacter13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter13()
}

func (c *current) onnon_escape_character1(char any) (any, error) {
	return string(c.text), nil
}

func (p *parser) callonnon_escape_character1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onnon_escape_character1(stack["char"])
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expresssions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//	input := "input"
//	stats := Stats{}
//	_, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//	if err != nil {
//	    log.Panicln(err)
//	}
//	b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//	if err != nil {
//	    log.Panicln(err)
//	}
//	fmt.Println(string(b))
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i any, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (any, error) {
	b, err := io.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (any, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return strconv.Itoa(p.line) + ":" + strconv.Itoa(p.col) + " [" + strconv.Itoa(p.offset) + "]"
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]any

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        any
}

type choiceExpr struct {
	pos          position
	alternatives []any
}

type actionExpr struct {
	pos  position
	expr any
	run  func(*parser) (any, error)
}

type recoveryExpr struct {
	pos          position
	expr         any
	recoverExpr  any
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []any
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  any
}

type expr struct {
	pos  position
	expr any
}

type (
	andExpr        expr
	notExpr        expr
	zeroOrOneExpr  expr
	zeroOrMoreExpr expr
	oneOrMoreExpr  expr
)

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
	want       string
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   any
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[any]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]any
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]any
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]any)
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr any) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]any, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) printIndent(mark string, s string) string {
	return p.print(strings.Repeat(" ", p.depth)+mark, s)
}

func (p *parser) in(s string) string {
	res := p.printIndent(">", s)
	p.depth++
	return res
}

func (p *parser) out(s string) string {
	p.depth--
	return p.printIndent("<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() any
}

var statePool = &sync.Pool{
	New: func() any { return make(storeDict) },
}

func (sd storeDict) Discard() {
	for k := range sd {
		delete(sd, k)
	}
	statePool.Put(sd)
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	state := statePool.Get().(storeDict)
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state.Discard()
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node any) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node any, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[any]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[any]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val any, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRuleWrap(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return strings.Join(list[:len(list)-1], sep) + " " + lastSep + " " + list[len(list)-1]
	}
}

func (p *parser) parseRuleMemoize(rule *rule) (any, bool) {
	res, ok := p.getMemoized(rule)
	if ok {
		p.restore(res.end)
		return res.v, res.b
	}

	startMark := p.pt
	val, ok := p.parseRule(rule)
	p.setMemoized(startMark, rule, resultTuple{val, ok, p.pt})

	return val, ok
}

func (p *parser) parseRuleWrap(rule *rule) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}
	var (
		val       any
		ok        bool
		startMark = p.pt
	)

	if p.memoize {
		val, ok = p.parseRuleMemoize(rule)
	} else {
		val, ok = p.parseRule(rule)
	}

	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(startMark)))
	}
	return val, ok
}

func (p *parser) parseRule(rule *rule) (any, bool) {
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExprWrap(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	return val, ok
}

func (p *parser) parseExprWrap(expr any) (any, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	val, ok := p.parseExpr(expr)

	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr any) (any, bool) {
	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val any
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExprWrap(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExprWrap(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExprWrap(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExprWrap(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, lit.want)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, lit.want)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExprWrap(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExprWrap(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRuleWrap(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]any, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExprWrap(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExprWrap(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExprWrap(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
